=== added directory 'BUILD'
=== added file 'BUILD/.cvsignore'
--- BUILD/.cvsignore	1970-01-01 00:00:00 +0000
+++ BUILD/.cvsignore	2008-06-25 05:29:13 +0000
@@ -0,0 +1,1 @@
+compile-pentium-test

=== added file 'BUILD/FINISH.sh'
--- BUILD/FINISH.sh	1970-01-01 00:00:00 +0000
+++ BUILD/FINISH.sh	2008-06-25 05:29:13 +0000
@@ -0,0 +1,42 @@
+cflags="$c_warnings $extra_flags"
+cxxflags="$cxx_warnings $base_cxxflags $extra_flags"
+extra_configs="$extra_configs $local_infile_configs"
+configure="./configure $base_configs $extra_configs"
+
+commands="\
+$make -k maintainer-clean || true 
+/bin/rm -rf */.deps/*.P configure config.cache storage/*/configure storage/*/config.cache autom4te.cache storage/*/autom4te.cache;
+
+path=`dirname $0`
+. \"$path/autorun.sh\""
+
+if [ -z "$just_clean" ]
+then
+commands="$commands
+CC=\"$CC\" CFLAGS=\"$cflags\" CXX=\"$CXX\" CXXFLAGS=\"$cxxflags\" CXXLDFLAGS=\"$CXXLDFLAGS\" \
+$configure"
+fi
+
+if [ -z "$just_configure" -a -z "$just_clean" ]
+then
+  commands="$commands
+
+$make $AM_MAKEFLAGS"
+
+  if [ "x$strip" = "xyes" ]
+  then
+    commands="$commands
+
+mkdir -p tmp
+nm --numeric-sort sql/mysqld  > tmp/mysqld.sym
+objdump -d sql/mysqld > tmp/mysqld.S
+strip sql/mysqld"
+  fi
+fi
+
+if test -z "$just_print"
+then
+  eval "set -x; $commands"
+else
+  echo "$commands"
+fi

=== added file 'BUILD/Makefile.am'
--- BUILD/Makefile.am	1970-01-01 00:00:00 +0000
+++ BUILD/Makefile.am	2008-06-25 05:29:13 +0000
@@ -0,0 +1,66 @@
+# Copyright (C) 2002, 2004-2005 MySQL AB
+#
+# This library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Library General Public
+# License as published by the Free Software Foundation; version 2
+# of the License.
+#
+# This library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Library General Public License for more details.
+#
+# You should have received a copy of the GNU Library General Public
+# License along with this library; if not, write to the Free
+# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+# MA 02111-1307, USA
+
+## Process this file with automake to create Makefile.in
+
+EXTRA_DIST =		FINISH.sh \
+			SETUP.sh \
+			autorun.sh \
+			check-cpu \
+			cleanup \
+			compile-alpha \
+			compile-alpha-ccc \
+			compile-alpha-cxx \
+			compile-alpha-debug \
+			compile-amd64-debug-max \
+			compile-amd64-max \
+			compile-amd64-max-sci \
+			compile-darwin-mwcc \
+			compile-dist \
+			compile-hpux11-parisc2-aCC \
+			compile-ia64-debug-max \
+			compile-irix-mips64-mipspro \
+			compile-pentium \
+			compile-pentium-debug \
+			compile-pentium-debug-max \
+			compile-pentium-debug-openssl \
+			compile-pentium-debug-yassl \
+			compile-pentium-gcov \
+			compile-pentium-gprof \
+			compile-pentium-icc \
+			compile-pentium-icc-valgrind-max \
+			compile-pentium-icc-yassl \
+			compile-pentium-max \
+			compile-pentium-myodbc \
+			compile-pentium-mysqlfs-debug \
+			compile-pentium-pgcc \
+			compile-pentium-valgrind-max \
+			compile-pentium64-debug \
+			compile-pentium64-debug-max \
+			compile-pentium64-max-sci \
+			compile-pentium64-valgrind-max \
+			compile-ppc \
+			compile-ppc-debug \
+			compile-ppc-debug-max \
+			compile-ppc-max \
+			compile-solaris-sparc \
+			compile-solaris-sparc-debug \
+			compile-solaris-sparc-forte \
+			compile-solaris-sparc-purify
+
+# Don't update the files from bitkeeper
+%::SCCS/s.%

=== added file 'BUILD/SETUP.sh'
--- BUILD/SETUP.sh	1970-01-01 00:00:00 +0000
+++ BUILD/SETUP.sh	2008-06-25 05:29:13 +0000
@@ -0,0 +1,229 @@
+#!/bin/sh
+
+########################################################################
+
+get_key_value()
+{
+  echo "$1" | sed 's/^--[a-zA-Z_-]*=//'
+}
+
+usage()
+{
+cat <<EOF 
+Usage: $0 [-h|-n] [configure-options]
+  -h, --help              Show this help message.
+  -n, --just-print        Don't actually run any commands; just print them.
+  -c, --just-configure    Stop after running configure.
+  --with-debug=full       Build with full debug.
+  --warning-mode=[old|pedantic]
+                          Influences the debug flags. Old is default.
+  --prefix=path           Build with prefix 'path'.
+
+Note: this script is intended for internal use by MySQL developers.
+EOF
+}
+
+parse_options()
+{
+  while test $# -gt 0
+  do
+    case "$1" in
+    --prefix=*)
+      prefix=`get_key_value "$1"`;;
+    --with-debug=full)
+      full_debug="=full";;
+    --warning-mode=*)
+      warning_mode=`get_key_value "$1"`;;
+    -c | --just-configure)
+      just_configure=1;;
+    -n | --just-print | --print)
+      just_print=1;;
+    -h | --help)
+      usage
+      exit 0;;
+    *)
+      echo "Unknown option '$1'"
+      exit 1;;
+    esac
+    shift
+  done
+}
+
+########################################################################
+
+if test ! -f sql/mysqld.cc
+then
+  echo "You must run this script from the MySQL top-level directory"
+  exit 1
+fi
+
+prefix="/usr/local/mysql"
+just_print=
+just_configure=
+full_debug=
+warning_mode=
+
+parse_options "$@"
+
+if test -n "$MYSQL_BUILD_PREFIX"
+then
+  prefix="$MYSQL_BUILD_PREFIX"
+fi
+
+set -e
+
+#
+# Check for the CPU and set up CPU specific flags. We may reset them
+# later.
+# 
+path=`dirname $0`
+. "$path/check-cpu"
+
+export AM_MAKEFLAGS
+AM_MAKEFLAGS="-j 4"
+
+if [ "x$warning_mode" != "xpedantic" ]; then
+# Both C and C++ warnings
+  warnings="-Wimplicit -Wreturn-type -Wswitch -Wtrigraphs -Wcomment -W"
+  warnings="$warnings -Wchar-subscripts -Wformat -Wparentheses -Wsign-compare"
+  warnings="$warnings -Wwrite-strings -Wunused-function -Wunused-label -Wunused-value -Wunused-variable"
+
+# For more warnings, uncomment the following line
+# warnings="$global_warnings -Wshadow"
+
+# C warnings
+  c_warnings="$warnings -Wunused-parameter"
+# C++ warnings
+  cxx_warnings="$warnings"
+# cxx_warnings="$cxx_warnings -Woverloaded-virtual -Wsign-promo"
+  cxx_warnings="$cxx_warnings -Wreorder"
+  cxx_warnings="$cxx_warnings -Wctor-dtor-privacy -Wnon-virtual-dtor"
+# Added unless --with-debug=full
+  debug_extra_cflags="-O1 -Wuninitialized"
+else
+  warnings="-W -Wall -ansi -pedantic -Wno-long-long -Wno-unused -D_POSIX_SOURCE"
+  c_warnings="$warnings"
+  cxx_warnings="$warnings -std=c++98"
+# NOTE: warning mode should not influence optimize/debug mode.
+# Please feel free to add a separate option if you don't feel it's an overkill.
+  debug_extra_cflags="-O0"
+# Reset CPU flags (-mtune), they don't work in -pedantic mode
+  check_cpu_cflags=""
+fi
+
+# Set flags for various build configurations.
+# Used in -valgrind builds
+valgrind_flags="-UFORCE_INIT_OF_VARS -DHAVE_purify "
+valgrind_flags="$valgrind_flags -DMYSQL_SERVER_SUFFIX=-valgrind-max"
+#
+# Used in -debug builds
+debug_cflags="-DUNIV_MUST_NOT_INLINE -DEXTRA_DEBUG -DFORCE_INIT_OF_VARS "
+debug_cflags="$debug_cflags -DSAFE_MUTEX"
+error_inject="--with-error-inject "
+#
+# Base C++ flags for all builds
+base_cxxflags="-felide-constructors -fno-exceptions -fno-rtti"
+#
+# Flags for optimizing builds.
+# Be as fast as we can be without losing our ability to backtrace.
+fast_cflags="-O3 -fno-omit-frame-pointer"
+
+debug_configs="--with-debug$full_debug"
+if [ -z "$full_debug" ]
+then
+  debug_cflags="$debug_cflags $debug_extra_cflags"
+fi
+
+#
+# Configuration options.
+#
+base_configs="--prefix=$prefix --enable-assembler "
+base_configs="$base_configs --with-extra-charsets=complex "
+base_configs="$base_configs --enable-thread-safe-client "
+base_configs="$base_configs --with-big-tables"
+
+if test -d "$path/../cmd-line-utils/readline"
+then
+    base_configs="$base_configs --with-readline"
+elif test -d "$path/../cmd-line-utils/libedit"
+then
+    base_configs="$base_configs --with-libedit"
+fi
+
+static_link="--with-mysqld-ldflags=-all-static "
+static_link="$static_link --with-client-ldflags=-all-static"
+# we need local-infile in all binaries for rpl000001
+# if you need to disable local-infile in the client, write a build script
+# and unset local_infile_configs
+local_infile_configs="--enable-local-infile"
+
+
+max_no_embedded_configs="--with-plugins=max"
+max_configs="--with-plugins=max --with-libevent"
+
+#
+# CPU and platform specific compilation flags.
+#
+alpha_cflags="$check_cpu_cflags -Wa,-m$cpu_flag"
+amd64_cflags="$check_cpu_cflags"
+amd64_cxxflags=""  # If dropping '--with-big-tables', add here  "-DBIG_TABLES"
+pentium_cflags="$check_cpu_cflags"
+pentium64_cflags="$check_cpu_cflags -m64"
+ppc_cflags="$check_cpu_cflags"
+sparc_cflags="-mcpu=ultrasparc"
+
+if gmake --version > /dev/null 2>&1
+then
+  make=gmake
+else
+  make=make
+fi
+
+if test -z "$CC" ; then
+  CC=gcc
+fi
+
+if test -z "$CXX" ; then
+  CXX=gcc
+fi
+
+# If ccache (a compiler cache which reduces build time)
+# (http://samba.org/ccache) is installed, use it.
+# We use 'grep' and hope 'grep' will work as expected
+# (returns 0 if finds lines)
+if test "$USING_GCOV" != "1"
+then
+  # Not using gcov; Safe to use ccache
+  CCACHE_GCOV_VERSION_ENABLED=1
+fi
+
+if ccache -V > /dev/null 2>&1 && test "$CCACHE_GCOV_VERSION_ENABLED" = "1"
+then
+  echo "$CC" | grep "ccache" > /dev/null || CC="ccache $CC"
+  echo "$CXX" | grep "ccache" > /dev/null || CXX="ccache $CXX"
+fi
+
+# gcov
+
+# The  -fprofile-arcs and -ftest-coverage options cause GCC to instrument the
+# code with profiling information used by gcov.
+# The -DDISABLE_TAO_ASM is needed to avoid build failures in Yassl.
+# The -DHAVE_gcov enables code to write out coverage info even when crashing.
+
+gcov_compile_flags="-fprofile-arcs -ftest-coverage"
+gcov_compile_flags="$gcov_compile_flags -DDISABLE_TAO_ASM"
+gcov_compile_flags="$gcov_compile_flags -DMYSQL_SERVER_SUFFIX=-gcov -DHAVE_gcov"
+
+# GCC4 needs -fprofile-arcs -ftest-coverage on the linker command line (as well
+# as on the compiler command line), and this requires setting LDFLAGS for BDB.
+
+gcov_link_flags="-fprofile-arcs -ftest-coverage"
+
+gcov_configs="--disable-shared"
+
+# gprof
+
+gprof_compile_flags="-O2 -pg -g"
+
+gprof_link_flags="--disable-shared $static_link"
+

=== added file 'BUILD/autorun.sh'
--- BUILD/autorun.sh	1970-01-01 00:00:00 +0000
+++ BUILD/autorun.sh	2008-06-25 05:29:13 +0000
@@ -0,0 +1,31 @@
+#!/bin/sh
+# Create MySQL autotools infrastructure
+
+die() { echo "$@"; exit 1; }
+
+# Handle "glibtoolize" (e.g., for native OS X autotools) as another
+# name for "libtoolize". Use the first one, either name, found in PATH.
+LIBTOOLIZE=libtoolize  # Default
+IFS="${IFS=   }"; save_ifs="$IFS"; IFS=':'
+for dir in $PATH
+do
+  if test -x $dir/glibtoolize
+  then
+    LIBTOOLIZE=glibtoolize
+    break
+  elif test -x $dir/libtoolize
+  then
+    break
+  fi
+done
+IFS="$save_ifs"
+
+aclocal || die "Can't execute aclocal" 
+autoheader || die "Can't execute autoheader"
+# --force means overwrite ltmain.sh script if it already exists 
+$LIBTOOLIZE --automake --force --copy || die "Can't execute libtoolize"
+  
+# --add-missing instructs automake to install missing auxiliary files
+# and --force to overwrite them if they already exist
+automake --add-missing --force  --copy || die "Can't execute automake"
+autoconf || die "Can't execute autoconf"

=== added file 'BUILD/check-cpu'
--- BUILD/check-cpu	1970-01-01 00:00:00 +0000
+++ BUILD/check-cpu	2008-06-25 05:29:13 +0000
@@ -0,0 +1,241 @@
+#!/bin/sh
+#
+# Check cpu of current machine and find the
+# best compiler optimization flags for gcc
+# Will return result in:
+# cpu_arg        : Type of CPU
+# check_cpu_args : Arguments for GCC compiler settings
+#
+
+check_cpu () {
+  CPUINFO=/proc/cpuinfo
+  if test -n "$TEST_CPUINFO" ; then
+    CPUINFO=$TEST_CPUINFO
+  fi
+  if test -r "$CPUINFO" -a "$CPUINFO" != " " ; then
+    # on Linux (and others?) we can get detailed CPU information out of /proc
+    cpuinfo="cat $CPUINFO"
+
+    # detect CPU family
+    cpu_family=`$cpuinfo | grep 'family' | cut -d ':' -f 2 | cut -d ' ' -f 2 | head -1`
+    if test -z "$cpu_family" ; then
+      cpu_family=`$cpuinfo | grep 'cpu' | cut -d ':' -f 2 | cut -d ' ' -f 2 | head -1`
+    fi
+
+    # detect CPU vendor and model
+    cpu_vendor=`$cpuinfo | grep 'vendor_id' | cut -d ':' -f 2 | cut -d ' ' -f 2 | head -1`
+    model_name=`$cpuinfo | grep 'model name' | cut -d ':' -f 2 | head -1`
+    if test -z "$model_name" ; then
+      model_name=`$cpuinfo | grep 'cpu model' | cut -d ':' -f 2 | head -1`
+    fi
+
+    # fallback: get CPU model from uname output
+    if test -z "$model_name" ; then
+      model_name=`uname -m`
+    fi
+
+    # parse CPU flags
+    for flag in `$cpuinfo | grep '^flags' | sed -e 's/^flags.*: //' -e 's/[^a-zA-Z0-9_ ]/_/g'`; do 
+      eval cpu_flag_$flag=yes
+    done
+  else
+    # Fallback when there is no /proc/cpuinfo
+    CPUINFO=" "
+    case "`uname -s`" in
+      FreeBSD|OpenBSD)
+        cpu_family=`uname -m`;
+        model_name=`sysctl -n hw.model`
+        ;;
+      Darwin)
+        cpu_family=`uname -p`
+        model_name=`machine`
+        ;;
+      *)
+        cpu_family=`uname -m`;
+        model_name=`uname -p`;
+        ;;
+    esac
+  fi
+
+  # detect CPU shortname as used by gcc options 
+  # this list is not complete, feel free to add further entries
+  cpu_arg=""
+  case "$cpu_family--$model_name" in
+    # DEC Alpha
+    Alpha*EV6*)
+      cpu_arg="ev6";
+      ;;
+    # Intel ia32
+    *Intel*Core*|*X[eE][oO][nN]*)
+      # a Xeon is just another pentium4 ...
+      # ... unless it has the "lm" (long-mode) flag set, 
+      # in that case it's a Xeon with EM64T support
+      # If SSE3 support exists it is a Core2 Duo or newer
+      # So is Intel Core.
+      if [ -z "$cpu_flag_lm" ]; then
+        cpu_arg="pentium4"
+      else
+        cpu_arg="nocona"
+      fi
+      if test -z "$cpu_flag_ssse3" ; then
+        core2="no"
+      else
+        core2="yes"
+      fi
+      ;;
+    *Pentium*4*Mobile*)
+      cpu_arg="pentium4m"
+      ;;
+    *Pentium*4*)
+      cpu_arg="pentium4"
+      ;;
+    *Pentium*III*Mobile*)
+      cpu_arg="pentium3m"
+      ;;
+    *Pentium*III*)
+      cpu_arg="pentium3"
+      ;;
+    *Pentium*M*pro*)
+      cpu_arg="pentium-m"
+    ;;
+    *Celeron\(R\)*\ M*)
+      cpu_arg="pentium-m"
+      ;;
+    *Celeron*Coppermine*)
+      cpu_arg="pentium3"
+      ;;
+    *Celeron\(R\)*)
+      cpu_arg="pentium4"
+      ;;
+    *Celeron*)
+      cpu_arg="pentium2"
+      ;;
+    *Turion*)
+      cpu_arg="athlon64"
+      ;;
+    *Athlon*64*)
+      cpu_arg="athlon64"
+      ;;
+    *Athlon*)
+      cpu_arg="athlon"
+      ;;
+    *Opteron*)
+      cpu_arg="opteron"
+      ;;
+    # MacOSX / Intel  
+    *i386*i486*)
+      cpu_arg="pentium-m"
+      ;;
+    *i386*)
+      cpu_arg="i386"
+      ;;
+    #Core 2 Duo  
+    *Intel*Core\(TM\)2*)
+      cpu_arg="nocona"
+      ;;
+    # Intel ia64
+    *Itanium*)
+      cpu_arg="itanium"
+      ;;
+    # Solaris Sparc
+    *sparc*sun4u*)
+      cpu_arg="sparc"
+      ;;
+    # Power PC
+    *ppc*)
+      cpu_arg="powerpc"
+      ;;
+    *powerpc*)
+      cpu_arg="powerpc"
+      ;;
+    # unknown
+    *)
+      cpu_arg=""
+      ;;
+  esac
+
+  if test -z "$cpu_arg" ; then
+    if test "$CPUINFO" != " " ; then
+      # fallback to uname if necessary
+      TEST_CPUINFO=" "
+      check_cpu_cflags=""
+      check_cpu
+      return
+    fi
+    echo "BUILD/check-cpu: Oops, could not find out what kind of cpu this machine is using." >&2
+    check_cpu_cflags=""
+    return
+  fi
+
+  # different compiler versions have different option names
+  # for CPU specific command line options
+  if test -z "$CC" ; then
+    cc="gcc";
+  else
+    cc=$CC
+  fi
+
+  cc_ver=`$cc --version | sed 1q`
+  cc_verno=`echo $cc_ver | sed -e 's/^.*gcc/gcc/g; s/[^0-9. ]//g;	 s/^ *//g; s/ .*//g'`
+  set -- `echo $cc_verno | tr '.' ' '`
+  cc_major=$1
+  cc_minor=$2
+  cc_patch=$3
+  cc_comp=`expr $cc_major '*' 100 '+' $cc_minor`
+  
+  case "$cc_ver--$cc_verno" in
+    *GCC*)
+        # different gcc backends (and versions) have different CPU flags
+        case `gcc -dumpmachine` in
+          i?86-* | x86_64-*)
+	    if test "$cc_comp" -lt 304 ; then
+              check_cpu_cflags="-mcpu=${cpu_arg}"
+            elif test "$cc_comp" -ge 402 ; then
+              check_cpu_cflags="-mtune=native"
+            else
+              check_cpu_cflags="-mtune=${cpu_arg}"
+            fi
+            ;;
+          ppc-*)
+              check_cpu_cflags="-mcpu=${cpu_arg} -mtune=${cpu_arg}"
+            ;;
+          *)
+            check_cpu_cflags=""
+            return
+            ;;
+        esac
+      ;;
+    2.95.*)
+      # GCC 2.95 doesn't expose its name in --version output
+      check_cpu_cflags="-m${cpu_arg}"
+      ;;
+    *)
+      check_cpu_cflags=""
+      return
+      ;;
+  esac
+
+  # now we check whether the compiler really understands the cpu type
+  touch __test.c
+
+  if test "x$core2" = "xyes" ; then
+    cpu_arg="core2"
+  fi
+  while [ "$cpu_arg" ] ; do
+    printf "testing $cpu_arg ... " >&2
+          
+    # compile check
+    eval "$cc -c $check_cpu_cflags __test.c" 2>/dev/null
+    if test "x$?" = "x0" ; then
+      echo ok >&2
+      break;
+    fi
+
+    echo failed >&2
+    check_cpu_cflags=""
+    break;
+  done
+  rm __test.*
+}
+ 
+check_cpu

=== added file 'BUILD/cleanup'
--- BUILD/cleanup	1970-01-01 00:00:00 +0000
+++ BUILD/cleanup	2008-06-25 05:29:13 +0000
@@ -0,0 +1,8 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+just_clean=1;
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-debug-max'
--- BUILD/compile-amd64-debug-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-debug-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,7 @@
+#! /bin/sh
+path=`dirname $0`
+. "$path/SETUP.sh"
+extra_flags="$amd64_cflags $debug_cflags"
+extra_configs="$amd64_configs $debug_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-gcov'
--- BUILD/compile-amd64-gcov	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-gcov	2008-06-25 05:29:13 +0000
@@ -0,0 +1,17 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+# Need to disable ccache, or we loose the gcov-needed compiler output files.
+CCACHE_DISABLE=1
+export CCACHE_DISABLE
+
+export LDFLAGS="$gcov_link_flags"
+
+extra_flags="$amd64_cflags $debug_cflags $max_cflags $gcov_compile_flags"
+c_warnings="$c_warnings $debug_extra_warnings"
+cxx_warnings="$cxx_warnings $debug_extra_warnings"
+extra_configs="$amd64_configs $debug_configs $gcov_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-gprof'
--- BUILD/compile-amd64-gprof	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-gprof	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$amd64_cflags $gprof_compile_flags"
+extra_configs="$amd64_configs $debug_configs $gprof_link_flags"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-max'
--- BUILD/compile-amd64-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,8 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+extra_flags="$amd64_cflags $fast_cflags -g"
+extra_configs="$amd64_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-max-sci'
--- BUILD/compile-amd64-max-sci	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-max-sci	2008-06-25 05:29:13 +0000
@@ -0,0 +1,8 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+extra_flags="$amd64_cflags $fast_cflags -g"
+extra_configs="$amd64_configs $max_configs --with-ndb-sci=/opt/DIS"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-noopt'
--- BUILD/compile-amd64-noopt	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-noopt	2008-06-25 05:29:13 +0000
@@ -0,0 +1,8 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+extra_flags="$amd64_cflags -g"
+extra_configs="$amd64_configs $max_no_ndb_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-amd64-valgrind-max'
--- BUILD/compile-amd64-valgrind-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-amd64-valgrind-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,24 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$amd64_cflags $debug_cflags $valgrind_flags"
+extra_configs="$amd64_configs $debug_configs $max_configs"
+
+. "$path/FINISH.sh"
+
+if test -z "$just_print"
+then
+  set +v +x
+  echo "\
+******************************************************************************
+Note that by default BUILD/compile-pentium-valgrind-max calls 'configure' with
+--enable-assembler. When Valgrind detects an error involving an assembly
+function (for example an uninitialized value used as an argument of an
+assembly function), Valgrind will not print the stacktrace and 'valgrind
+--gdb-attach=yes' will not work either. If you need a stacktrace in those
+cases, you have to run BUILD/compile-pentium-valgrind-max with the
+--disable-assembler argument.
+******************************************************************************"
+fi

=== added file 'BUILD/compile-pentium'
--- BUILD/compile-pentium	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $fast_cflags -g"
+extra_configs="$pentium_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-debug'
--- BUILD/compile-pentium-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,10 @@
+#! /bin/sh
+
+path=`dirname $0`
+set -- "$@" --with-debug=full
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $debug_cflags"
+extra_configs="$pentium_configs $debug_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-debug-max'
--- BUILD/compile-pentium-debug-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-debug-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,10 @@
+#! /bin/sh
+
+path=`dirname $0`
+set -- "$@" --with-debug=full
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $debug_cflags"
+extra_configs="$pentium_configs $debug_configs $max_configs $error_inject --with-experimental-collations"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-gcov'
--- BUILD/compile-pentium-gcov	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-gcov	2008-06-25 05:29:13 +0000
@@ -0,0 +1,30 @@
+#! /bin/sh
+
+# Need to disable ccache, or we loose the gcov-needed compiler output files.
+
+USING_GCOV=1
+CCACHE_GCOV_VERSION_ENABLED=0
+if ccache -V > /dev/null 2>&1
+then
+  CCACHE_VER=`ccache -V | head -1 | sed s/"ccache version "//`
+  if test "$CCACHE_VER" == "2.4-gcov"
+  then
+    CCACHE_GCOV_VERSION_ENABLED=1
+  else
+    CCACHE_DISABLE=1
+    export CCACHE_DISABLE
+  fi
+fi
+export CCACHE_GCOV_VERSION_ENABLED
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+export LDFLAGS="$gcov_link_flags"
+
+extra_flags="$pentium_cflags $debug_cflags $max_cflags $gcov_compile_flags"
+c_warnings="$c_warnings $debug_extra_warnings"
+cxx_warnings="$cxx_warnings $debug_extra_warnings"
+extra_configs="$pentium_configs $debug_configs $gcov_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-gprof'
--- BUILD/compile-pentium-gprof	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-gprof	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $gprof_compile_flags"
+extra_configs="$pentium_configs $debug_configs $gprof_link_flags"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-icc'
--- BUILD/compile-pentium-icc	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-icc	2008-06-25 05:29:13 +0000
@@ -0,0 +1,24 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+# Note that we can't use ccache with icc as the generated .deps file will
+# then contain wrong information
+CC=icc
+CXX=icpc
+CXXLD="$CXX -static-libcxa"
+export CC CXX CXXLD
+
+c_warnings=""
+cxx_warnings=""
+extra_flags="$fast_cflags -unroll2 -ip -mp -restrict"
+
+# Use -no-ipo if you get this error
+# IPO link: can not find "-lstdc++_shared"
+# icpc: error: problem during multi-file optimization compilation (code 1)
+extra_flags="$extra_flags -no-ipo"
+base_cxxflags="-fno-exceptions -fno-rtti"
+extra_configs="$pentium_configs $static_link"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-icc-valgrind-max'
--- BUILD/compile-pentium-icc-valgrind-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-icc-valgrind-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,34 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+# Note that we can't use ccache with icc as the generated .deps file will
+# then contain wrong information
+CC=icc
+CXX=icpc
+export CC CXX
+
+extra_flags="$pentium_cflags $debug_cflags $valgrind_flags"
+
+# Disable following warnings as these are generated by header files:
+# 161   unrecognized pragma
+# 444   destructor for base class xxx is not virtual
+# 279   controlling expression is constant
+# 810   conversion from ulonglong to ulong with cast
+# 981   operands are evaluated in unspecified order
+# 1292  warning for unknown 'attribute' options
+# 1469  "xxx" clobber ignored
+# 1572  floating-point equality and inequality comparisons are unreliable
+
+# In C++
+# 869    parameter "xxx" was never referenced
+#        (Problem with virtual functions)
+# 874   support for placement delete is disabled
+
+c_warnings="-Wall -Wcheck -wd161,444,279,810,981,1292,1469,1572"
+cxx_warnings="$c_warnings -wd869,874"
+base_cxxflags="-fno-exceptions -fno-rtti"
+extra_configs="$pentium_configs $debug_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-icc-yassl'
--- BUILD/compile-pentium-icc-yassl	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-icc-yassl	2008-06-25 05:29:13 +0000
@@ -0,0 +1,24 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+# Note that we can't use ccache with icc as the generated .deps file will
+# then contain wrong information
+CC=icc
+CXX=icpc
+CXXLD="$CXX -static-libcxa"
+export CC CXX CXXLD
+
+c_warnings=""
+cxx_warnings=""
+extra_flags="$fast_cflags -unroll2 -ip -mp -restrict"
+
+# Use -no-ipo if you get this error
+# IPO link: can not find "-lstdc++_shared"
+# icpc: error: problem during multi-file optimization compilation (code 1)
+extra_flags="$extra_flags -no-ipo"
+base_cxxflags="-fno-exceptions -fno-rtti"
+extra_configs="$pentium_configs $static_link --with-yassl"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-max'
--- BUILD/compile-pentium-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $fast_cflags -g"
+extra_configs="$pentium_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium-pgcc'
--- BUILD/compile-pentium-pgcc	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-pgcc	2008-06-25 05:29:13 +0000
@@ -0,0 +1,18 @@
+#! /bin/sh
+
+AM_MAKEFLAGS="-j 2"
+gmake -k maintainer-clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+path=`dirname $0`
+. "$path/autorun.sh"
+ 
+export PATH=/usr/local/pgcc/bin:$PATH
+CFLAGS="-Wimplicit -Wreturn-type -Wid-clash-51 -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wimplicit-function-dec -Wimplicit-int -Wparentheses -Wsign-compare -Wwrite-strings -Wunused  -O6 -mpentiumpro -fomit-frame-pointer -mstack-align-double" CXX=gcc CXXFLAGS="-Wimplicit -Wreturn-type -Wid-clash-51 -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wimplicit-function-dec -Wimplicit-int -Wparentheses -Wsign-compare -Wwrite-strings -Woverloaded-virtual -Wextern-inline -Wsign-promo -Wreorder -Wctor-dtor-privacy -Wnon-virtual-dtor -felide-constructors -fno-exceptions -fno-rtti -O6 -fomit-frame-pointer -mpentiumpro -mstack-align-double" ./configure --prefix=/usr/local/mysql --enable-assembler --with-extra-charsets=complex --enable-thread-safe-client --with-mysqld-ldflags=-all-static  --with-client-ldflags=-all-static
+ 
+gmake -j 4
+ 
+mkdir -p tmp
+nm --numeric-sort sql/mysqld  > tmp/mysqld.sym
+objdump -d sql/mysqld > tmp/mysqld.S
+strip sql/mysqld

=== added file 'BUILD/compile-pentium-valgrind-max'
--- BUILD/compile-pentium-valgrind-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium-valgrind-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,24 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium_cflags $debug_cflags $valgrind_flags"
+extra_configs="$pentium_configs $debug_configs $max_configs"
+
+. "$path/FINISH.sh"
+
+if test -z "$just_print"
+then
+  set +v +x
+  echo "\
+******************************************************************************
+Note that by default BUILD/compile-pentium-valgrind-max calls 'configure' with
+--enable-assembler. When Valgrind detects an error involving an assembly
+function (for example an uninitialized value used as an argument of an
+assembly function), Valgrind will not print the stacktrace and 'valgrind
+--gdb-attach=yes' will not work either. If you need a stacktrace in those
+cases, you have to run BUILD/compile-pentium-valgrind-max with the
+--disable-assembler argument.
+******************************************************************************"
+fi

=== added file 'BUILD/compile-pentium64'
--- BUILD/compile-pentium64	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64	2008-06-25 05:29:13 +0000
@@ -0,0 +1,11 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium64_cflags $fast_cflags"
+extra_configs="$pentium_configs $static_link"
+CC="$CC --pipe"
+strip=yes
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-debug'
--- BUILD/compile-pentium64-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,12 @@
+#! /bin/sh
+
+path=`dirname $0`
+set -- "$@" --with-debug=full
+. "$path/SETUP.sh"
+
+extra_flags="$pentium64_cflags $debug_cflags"
+extra_configs="$pentium_configs $debug_configs $static_link"
+
+extra_configs="$extra_configs "
+CC="$CC --pipe"
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-debug-max'
--- BUILD/compile-pentium64-debug-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-debug-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,12 @@
+#! /bin/sh
+
+path=`dirname $0`
+set -- "$@" --with-debug=full
+. "$path/SETUP.sh"
+
+extra_flags="$pentium64_cflags $debug_cflags"
+extra_configs="$pentium_configs $debug_configs $max_configs"
+
+extra_configs="$extra_configs "
+CC="$CC --pipe"
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-gcov'
--- BUILD/compile-pentium64-gcov	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-gcov	2008-06-25 05:29:13 +0000
@@ -0,0 +1,17 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+# Need to disable ccache, or we loose the gcov-needed compiler output files.
+CCACHE_DISABLE=1
+export CCACHE_DISABLE
+
+export LDFLAGS="$gcov_link_flags"
+
+extra_flags="$pentium64_cflags $debug_cflags $max_cflags $gcov_compile_flags"
+c_warnings="$c_warnings $debug_extra_warnings"
+cxx_warnings="$cxx_warnings $debug_extra_warnings"
+extra_configs="$pentium64_configs $debug_configs $gcov_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-gprof'
--- BUILD/compile-pentium64-gprof	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-gprof	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium64_cflags $gprof_compile_flags"
+extra_configs="$pentium64_configs $debug_configs $gprof_link_flags"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-max'
--- BUILD/compile-pentium64-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,11 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh" 
+
+extra_flags="$pentium64_cflags $fast_cflags"
+extra_configs="$pentium_configs $max_configs $static_link"
+CC="$CC --pipe"
+strip=yes
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-pentium64-valgrind-max'
--- BUILD/compile-pentium64-valgrind-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-pentium64-valgrind-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,24 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$pentium64_cflags $debug_cflags $valgrind_flags"
+extra_configs="$pentium_configs $debug_configs $max_configs"
+
+. "$path/FINISH.sh"
+
+if test -z "$just_print"
+then
+  set +v +x
+  echo "\
+******************************************************************************
+Note that by default BUILD/compile-pentium-valgrind-max calls 'configure' with
+--enable-assembler. When Valgrind detects an error involving an assembly
+function (for example an uninitialized value used as an argument of an
+assembly function), Valgrind will not print the stacktrace and 'valgrind
+--gdb-attach=yes' will not work either. If you need a stacktrace in those
+cases, you have to run BUILD/compile-pentium-valgrind-max with the
+--disable-assembler argument.
+******************************************************************************"
+fi

=== added file 'BUILD/compile-ppc'
--- BUILD/compile-ppc	1970-01-01 00:00:00 +0000
+++ BUILD/compile-ppc	2008-06-25 05:29:13 +0000
@@ -0,0 +1,10 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$ppc_cflags $fast_cflags"
+extra_configs="$static_link"
+strip=yes
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-ppc-debug'
--- BUILD/compile-ppc-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-ppc-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,11 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$ppc_cflags $debug_cflags"
+extra_configs="$debug_configs "
+
+extra_configs="$extra_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-ppc-debug-max'
--- BUILD/compile-ppc-debug-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-ppc-debug-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$ppc_cflags $debug_cflags"
+extra_configs="$debug_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-ppc-max'
--- BUILD/compile-ppc-max	1970-01-01 00:00:00 +0000
+++ BUILD/compile-ppc-max	2008-06-25 05:29:13 +0000
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$ppc_cflags $fast_cflags -g"
+extra_configs="$extra_configs $max_configs"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-solaris-amd64-debug'
--- BUILD/compile-solaris-amd64-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-amd64-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,10 @@
+#! /bin/sh
+path=`dirname $0`
+. "$path/SETUP.sh"
+amd64_cflags="-m64 -mtune=athlon64"
+extra_flags="$amd64_cflags $debug_cflags $max_cflags"
+c_warnings="$c_warnings $debug_extra_warnings"
+cxx_warnings="$cxx_warnings $debug_extra_warnings"
+extra_configs="$amd64_configs $debug_configs $max_configs --enable-thread-safe-client"
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-solaris-amd64-forte'
--- BUILD/compile-solaris-amd64-forte	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-amd64-forte	2008-06-25 05:29:13 +0000
@@ -0,0 +1,52 @@
+#! /bin/sh
+
+gmake -k clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+path=`dirname $0`
+. "$path/autorun.sh"
+
+# For "optimal" code for this computer add -fast to EXTRA
+# To compile 64 bit, add -xarch=v9 to EXTRA_64_BIT
+
+EXTRA_64_BIT="-xarch=amd64"
+EXTRA="-fast"
+
+#
+# The following should not need to be touched
+#
+
+export CC CXX CFLAGS CXXFLAGS
+STD="-g -mt -D_FORTEC_ $EXTRA $EXTRA_64_BIT"
+ASFLAGS="$EXTRA_64_BIT"
+CC=cc-5.0
+CFLAGS="-Xa -xstrconst $STD"
+CXX=CC
+CXXFLAGS="-noex $STD"
+./configure \
+    --prefix=/usr/local/mysql \
+    --localstatedir=/usr/local/mysql/data \
+    --libexecdir=/usr/local/mysql/bin \
+    --with-extra-charsets=complex \
+    --enable-thread-safe-client \
+    --enable-local-infile \
+    --with-zlib-dir=bundled \
+    --with-big-tables \
+    --with-readline \
+    --with-archive-storage-engine \
+    --with-named-curses=-lcurses \
+    --with-big-tables \
+    --with-innodb \
+    --with-example-storage-engine \
+    --with-blackhole-storage-engine \
+    --with-federated-storage-engine \
+    --with-csv-storage-engine \
+    --with-ssl \
+    --enable-assembler
+
+# Not including:
+#     --with-ndbcluster
+#     --with-berkeley-db
+
+gmake -j4
+test $? = 0 && make test

=== added file 'BUILD/compile-solaris-amd64-forte-debug'
--- BUILD/compile-solaris-amd64-forte-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-amd64-forte-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,54 @@
+#! /bin/sh
+
+gmake -k clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+path=`dirname $0`
+. "$path/autorun.sh"
+
+# To compile 64 bit, add -xarch=amd64 to EXTRA_64_BIT
+EXTRA_64_BIT="-xarch=amd64"
+
+# For "optimal" code for this computer add -fast to EXTRA. Note that
+# this causes problem with debugging the program since -fast implies
+# -xO5.
+EXTRA=""
+
+#
+# The following should not need to be touched
+#
+
+export CC CXX CFLAGS CXXFLAGS
+STD="-g -mt -D_FORTEC_ $EXTRA $EXTRA_64_BIT $debug_cflags"
+ASFLAGS="$EXTRA_64_BIT"
+CC=cc-5.0
+CFLAGS="-Xa -xstrconst $STD"
+CXX=CC
+CXXFLAGS="-noex $STD"
+./configure \
+    --prefix=/usr/local/mysql \
+    --localstatedir=/usr/local/mysql/data \
+    --libexecdir=/usr/local/mysql/bin \
+    --with-extra-charsets=complex \
+    --enable-thread-safe-client \
+    --enable-local-infile \
+    --with-zlib-dir=bundled \
+    --with-big-tables \
+    --with-readline \
+    --with-archive-storage-engine \
+    --with-named-curses=-lcurses \
+    --with-big-tables \
+    --with-innodb \
+    --with-example-storage-engine \
+    --with-blackhole-storage-engine \
+    --with-federated-storage-engine \
+    --with-csv-storage-engine \
+    --with-ssl \
+    --with-debug \
+    --enable-assembler
+
+# Not including:
+#     --with-ndbcluster
+#     --with-berkeley-db
+
+gmake -j4

=== added file 'BUILD/compile-solaris-sparc'
--- BUILD/compile-solaris-sparc	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-sparc	2008-06-25 05:29:13 +0000
@@ -0,0 +1,14 @@
+#! /bin/sh
+
+make -k clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+# gcc is often in /usr/ccs/bin or /usr/local/bin
+PATH=$PATH:/usr/ccs/bin:/usr/local/bin
+
+path=`dirname $0`
+. "$path/autorun.sh"
+
+CFLAGS="-g -Wimplicit -Wreturn-type -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wparentheses -Wsign-compare -Wwrite-strings -Wunused  -O3 -fno-omit-frame-pointer -mcpu=v8 -Wa,-xarch=v8plusa" CXX=gcc CXXFLAGS="-Wimplicit -Wreturn-type -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wparentheses -Wsign-compare -Wwrite-strings -Woverloaded-virtual -Wsign-promo -Wreorder -Wctor-dtor-privacy -Wnon-virtual-dtor -felide-constructors -fno-exceptions -fno-rtti  -O3 -fno-omit-frame-pointer -mcpu=v8 -Wa,-xarch=v8plusa -g" ./configure --prefix=/usr/local/mysql --enable-assembler --with-extra-charsets=complex --enable-thread-safe-client
+
+make -j 4

=== added file 'BUILD/compile-solaris-sparc-debug'
--- BUILD/compile-solaris-sparc-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-sparc-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+make -k clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+path=`dirname $0`
+. "$path/autorun.sh"
+ 
+CFLAGS="-g -Wimplicit -Wreturn-type -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wparentheses -Wsign-compare -Wwrite-strings -Wunused  -O3 -fno-omit-frame-pointer" CXX=gcc CXXFLAGS="-g -Wimplicit -Wreturn-type -Wswitch -Wtrigraphs -Wcomment -W -Wchar-subscripts -Wformat -Wparentheses -Wsign-compare -Wwrite-strings -Woverloaded-virtual -Wsign-promo -Wreorder -Wctor-dtor-privacy -Wnon-virtual-dtor -felide-constructors -fno-exceptions -fno-rtti  -O3 -fno-omit-frame-pointer" ./configure --prefix=/usr/local/mysql --enable-assembler --with-extra-charsets=complex --enable-thread-safe-client --with-debug
+
+make -j 4

=== added file 'BUILD/compile-solaris-sparc-forte'
--- BUILD/compile-solaris-sparc-forte	1970-01-01 00:00:00 +0000
+++ BUILD/compile-solaris-sparc-forte	2008-06-25 05:29:13 +0000
@@ -0,0 +1,41 @@
+#! /bin/sh
+
+# Assume Forte is installed in /opt/SUNWSpro and ld is installed in
+# /usr/ccs/bin
+
+# Example PATH. You will need to use CC from forte, but use GNU for pretty much everything else
+# PATH=/opt/SUNWspro/bin:/usr/ccs/bin:/usr/sfw/bin:/opt/csw/bin:$PATH
+
+PREFIX="/usr/local/mysql"
+if test -n "$MYSQL_BUILD_PREFIX"
+then
+  PREFIX="$MYSQL_BUILD_PREFIX"
+fi
+
+make -k maintainer-clean || true
+/bin/rm -f */.deps/*.P config.cache
+ 
+path=`dirname $0`
+. "$path/autorun.sh"
+
+# For "optimal" code for this computer add -fast to EXTRA
+# To compile 32/64 bit, uncomment/comment EXTRA_64_BIT
+
+EXTRA_64_BIT="-m64"
+EXTRA="-fast"			# Remove comment to target current machine
+
+#
+# The following should not need to be touched
+#
+
+STD="-mt -D_FORTEC_ $EXTRA $EXTRA_64_BIT"
+CC=cc-5.0 CFLAGS="-Xa -xstrconst $STD" \
+DTRACEFLAGS='-64' \
+CXX=CC CXXFLAGS="-noex $STD" \
+./configure --enable-assembler --with-extra-charsets=complex --enable-thread-safe-client --prefix=$PREFIX --with-plugins=max --enable-dtrace
+
+make -j 4
+if [ $? = 0 ]
+then
+  make test
+fi

=== added file 'BUILD/compile-sparc'
--- BUILD/compile-sparc	1970-01-01 00:00:00 +0000
+++ BUILD/compile-sparc	2008-06-25 05:29:13 +0000
@@ -0,0 +1,10 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$sparc_cflags $fast_cflags"
+extra_configs="$static_link"
+strip=yes
+
+. "$path/FINISH.sh"

=== added file 'BUILD/compile-sparc-debug'
--- BUILD/compile-sparc-debug	1970-01-01 00:00:00 +0000
+++ BUILD/compile-sparc-debug	2008-06-25 05:29:13 +0000
@@ -0,0 +1,11 @@
+#! /bin/sh
+
+path=`dirname $0`
+. "$path/SETUP.sh"
+
+extra_flags="$sparc_cflags $debug_cflags"
+extra_configs="$debug_configs "
+
+extra_configs="$extra_configs"
+
+. "$path/FINISH.sh"

=== modified file 'Makefile.am'
--- Makefile.am	2008-06-29 23:41:16 +0000
+++ Makefile.am	2008-06-28 06:45:02 +0000
@@ -30,8 +30,8 @@
 			sql-common scripts \
 			strings mysys dbug extra regex libmysql libmysql_r client unittest storage plugin \
 			vio sql tests \
-			mysql-test support-files
-
+			mysql-test support-files \
+			BUILD
 DISTCLEANFILES = ac_available_languages_fragment
 
 # Create permission databases

=== removed file 'autorun.sh'
--- autorun.sh	2008-06-29 23:41:59 +0000
+++ autorun.sh	1970-01-01 00:00:00 +0000
@@ -1,31 +0,0 @@
-#!/bin/sh
-# Create MySQL autotools infrastructure
-
-die() { echo "$@"; exit 1; }
-
-# Handle "glibtoolize" (e.g., for native OS X autotools) as another
-# name for "libtoolize". Use the first one, either name, found in PATH.
-LIBTOOLIZE=libtoolize  # Default
-IFS="${IFS=   }"; save_ifs="$IFS"; IFS=':'
-for dir in $PATH
-do
-  if test -x $dir/glibtoolize
-  then
-    LIBTOOLIZE=glibtoolize
-    break
-  elif test -x $dir/libtoolize
-  then
-    break
-  fi
-done
-IFS="$save_ifs"
-
-aclocal || die "Can't execute aclocal" 
-autoheader || die "Can't execute autoheader"
-# --force means overwrite ltmain.sh script if it already exists 
-$LIBTOOLIZE --automake --force --copy || die "Can't execute libtoolize"
-  
-# --add-missing instructs automake to install missing auxiliary files
-# and --force to overwrite them if they already exist
-automake --add-missing --force  --copy || die "Can't execute automake"
-autoconf || die "Can't execute autoconf"

=== modified file 'client/get_password.c'
--- client/get_password.c	2008-06-30 01:08:38 +0000
+++ client/get_password.c	2008-06-25 05:29:13 +0000
@@ -32,29 +32,74 @@
 #include <pwd.h>
 #endif /* HAVE_PWD_H */
 #else /* ! HAVE_GETPASS */
- #include <sys/ioctl.h>
- #ifdef HAVE_TERMIOS_H				/* For tty-password */
-  #include	<termios.h>
-  #define TERMIO	struct termios
- #else
-  #ifdef HAVE_TERMIO_H				/* For tty-password */
-   #include	<termio.h>
-   #define TERMIO	struct termio
-  #else
-   #include	<sgtty.h>
-   #define TERMIO	struct sgttyb
-  #endif
- #endif
- #ifdef alpha_linux_port
-  #include <asm/ioctls.h>				/* QQ; Fix this in configure */
-  #include <asm/termiobits.h>
- #endif
+#ifndef __WIN__
+#include <sys/ioctl.h>
+#ifdef HAVE_TERMIOS_H				/* For tty-password */
+#include	<termios.h>
+#define TERMIO	struct termios
+#else
+#ifdef HAVE_TERMIO_H				/* For tty-password */
+#include	<termio.h>
+#define TERMIO	struct termio
+#else
+#include	<sgtty.h>
+#define TERMIO	struct sgttyb
+#endif
+#endif
+#ifdef alpha_linux_port
+#include <asm/ioctls.h>				/* QQ; Fix this in configure */
+#include <asm/termiobits.h>
+#endif
+#else
+#include <conio.h>
+#endif /* __WIN__ */
 #endif /* HAVE_GETPASS */
 
 #ifdef HAVE_GETPASSPHRASE			/* For Solaris */
 #define getpass(A) getpassphrase(A)
 #endif
 
+#ifdef __WIN__
+/* were just going to fake it here and get input from
+   the keyboard */
+
+char *get_tty_password(const char *opt_message)
+{
+  char to[80];
+  char *pos=to,*end=to+sizeof(to)-1;
+  int i=0;
+  DBUG_ENTER("get_tty_password");
+  _cputs(opt_message ? opt_message : "Enter password: ");
+  for (;;)
+  {
+    char tmp;
+    tmp=_getch();
+    if (tmp == '\b' || (int) tmp == 127)
+    {
+      if (pos != to)
+      {
+	_cputs("\b \b");
+	pos--;
+	continue;
+      }
+    }
+    if (tmp == '\n' || tmp == '\r' || tmp == 3)
+      break;
+    if (iscntrl(tmp) || pos == end)
+      continue;
+    _cputs("*");
+    *(pos++) = tmp;
+  }
+  while (pos != to && isspace(pos[-1]) == ' ')
+    pos--;					/* Allow dummy space at end */
+  *pos=0;
+  _cputs("\n");
+  DBUG_RETURN(my_strdup(to,MYF(MY_FAE)));
+}
+
+#else
+
+
 #ifndef HAVE_GETPASS
 /*
 ** Can't use fgets, because readline will get confused
@@ -163,3 +208,4 @@
   DBUG_RETURN(my_strdup(buff,MYF(MY_FAE)));
 }
 
+#endif /*__WIN__*/

=== modified file 'client/mysql.cc'
--- client/mysql.cc	2008-06-30 01:11:33 +0000
+++ client/mysql.cc	2008-06-25 05:29:13 +0000
@@ -104,7 +104,7 @@
 #define cmp_database(cs,A,B) strcmp((A),(B))
 #endif
 
-#if !defined(THREAD)
+#if !defined( __WIN__) && !defined(__NETWARE__) && !defined(THREAD)
 #define USE_POPEN
 #endif
 
@@ -1297,7 +1297,18 @@
   return;
 
 err:
+#ifdef _WIN32
+  /*
+   When SIGINT is raised on Windows, the OS creates a new thread to handle the
+   interrupt. Once that thread completes, the main thread continues running 
+   only to find that it's resources have already been free'd when the sigint 
+   handler called mysql_end(). 
+  */
+  mysql_thread_end();
+  return;
+#else
   mysql_end(sig);
+#endif  
 }
 
 
@@ -1317,6 +1328,10 @@
    0, 0, 0, 0, 0},
   {"help", 'I', "Synonym for -?", 0, 0, 0, GET_NO_ARG, NO_ARG, 0,
    0, 0, 0, 0, 0},
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"auto-rehash", OPT_AUTO_REHASH,
    "Enable automatic rehashing. One doesn't need to use 'rehash' to get table and field completion, but startup and reconnecting may take a longer time. Disable with --disable-auto-rehash.",
    (uchar**) &opt_rehash, (uchar**) &opt_rehash, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0,
@@ -1423,6 +1438,10 @@
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's asked from the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection or 0 for default to, in "
    "order of preference, my.cnf, $MYSQL_TCP_PORT, "
 #if MYSQL_PORT_DEFAULT == 0
@@ -1515,6 +1534,11 @@
 
 static void usage(int version)
 {
+  /* Divert all help information on NetWare to logger screen. */
+#ifdef __NETWARE__
+#define printf	consoleprintf
+#endif
+
 #if defined(USE_LIBEDIT_INTERFACE)
   const char* readline= "";
 #else
@@ -1540,6 +1564,10 @@
   my_print_help(my_long_options);
   print_defaults("my", load_default_groups);
   my_print_variables(my_long_options);
+  NETWARE_SET_SCREEN_MODE(1);
+#ifdef __NETWARE__
+#undef printf
+#endif
 }
 
 
@@ -1548,6 +1576,11 @@
 	       char *argument)
 {
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case OPT_CHARSETS_DIR:
     strmake(mysql_charsets_dir, argument, sizeof(mysql_charsets_dir) - 1);
     charsets_dir = mysql_charsets_dir;
@@ -1778,6 +1811,15 @@
 
 static int read_and_execute(bool interactive)
 {
+#if defined(__NETWARE__)
+  char linebuffer[254];
+  String buffer;
+#endif
+#if defined(__WIN__)
+  String tmpbuf;
+  String buffer;
+#endif
+
   char	*line;
   char	in_string=0;
   ulong line_number=0;
@@ -1817,9 +1859,44 @@
       if (opt_outfile && glob_buffer.is_empty())
 	fflush(OUTFILE);
 
+#if defined( __WIN__) || defined(__NETWARE__)
+      tee_fputs(prompt, stdout);
+#if defined(__NETWARE__)
+      line=fgets(linebuffer, sizeof(linebuffer)-1, stdin);
+      /* Remove the '\n' */
+      if (line)
+      {
+        char *p = strrchr(line, '\n');
+        if (p != NULL)
+          *p = '\0';
+      }
+#else defined(__WIN__)
+      if (!tmpbuf.is_alloced())
+        tmpbuf.alloc(65535);
+      tmpbuf.length(0);
+      buffer.length(0);
+      size_t clen;
+      do
+      {
+	line= my_cgets((char*)tmpbuf.ptr(), tmpbuf.alloced_length()-1, &clen);
+        buffer.append(line, clen);
+        /* 
+           if we got buffer fully filled than there is a chance that
+           something else is still in console input buffer
+        */
+      } while (tmpbuf.alloced_length() <= clen);
+      /* 
+        An empty line is returned from my_cgets when there's error reading :
+        Ctrl-c for example
+      */
+      if (line)
+        line= buffer.c_ptr();
+#endif /* __NETWARE__ */
+#else
       if (opt_outfile)
 	fputs(prompt, OUTFILE);
       line= readline(prompt);
+#endif /* defined( __WIN__) || defined(__NETWARE__) */
 
       /*
         When Ctrl+d or Ctrl+z is pressed, the line may be NULL on some OS
@@ -1867,6 +1944,13 @@
     }
   }
 
+#if defined( __WIN__) || defined(__NETWARE__)
+  buffer.free();
+#endif
+#if defined( __WIN__)
+  tmpbuf.free();
+#endif
+
   return status.exit_status;
 }
 
@@ -3719,8 +3803,8 @@
   strxmov(buff,editor," ",filename,NullS);
   (void) system(buff);
 
-  struct stat stat_arg;
-  if (stat(filename,&stat_arg))
+  MY_STAT stat_arg;
+  if (!my_stat(filename,&stat_arg,MYF(MY_WME)))
     goto err;
   if ((fd = my_open(filename,O_RDONLY, MYF(MY_WME))) < 0)
     goto err;
@@ -3744,6 +3828,7 @@
 	 char *line __attribute__((unused)))
 {
   /* let the screen auto close on a normal shutdown */
+  NETWARE_SET_SCREEN_MODE(SCR_AUTOCLOSE_ON_EXIT);
   status.exit_status=0;
   return 1;
 }
@@ -4445,6 +4530,7 @@
 {
   va_list args;
 
+  NETWARE_YIELD;
   va_start(args, fmt);
   (void) vfprintf(file, fmt, args);
   va_end(args);
@@ -4460,6 +4546,7 @@
 
 void tee_fputs(const char *s, FILE *file)
 {
+  NETWARE_YIELD;
   fputs(s, file);
   if (opt_outfile)
     fputs(s, OUTFILE);
@@ -4468,6 +4555,7 @@
 
 void tee_puts(const char *s, FILE *file)
 {
+  NETWARE_YIELD;
   fputs(s, file);
   fputc('\n', file);
   if (opt_outfile)
@@ -4484,16 +4572,24 @@
     putc(c, OUTFILE);
 }
 
+#if defined( __WIN__) || defined(__NETWARE__)
+#include <time.h>
+#else
 #include <sys/times.h>
 #ifdef _SC_CLK_TCK				// For mit-pthreads
 #undef CLOCKS_PER_SEC
 #define CLOCKS_PER_SEC (sysconf(_SC_CLK_TCK))
 #endif
+#endif
 
 static ulong start_timer(void)
 {
+#if defined( __WIN__) || defined(__NETWARE__)
+ return clock();
+#else
   struct tms tms_tmp;
   return times(&tms_tmp);
+#endif
 }
 
 

=== modified file 'client/mysql_upgrade.c'
--- client/mysql_upgrade.c	2008-06-30 01:11:33 +0000
+++ client/mysql_upgrade.c	2008-06-25 05:29:13 +0000
@@ -23,7 +23,11 @@
 #endif
 
 #ifndef WEXITSTATUS
+# ifdef __WIN__
+#  define WEXITSTATUS(stat_val) (stat_val)
+# else
 #  define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
+# endif
 #endif
 
 static char mysql_path[FN_REFLEN];
@@ -87,6 +91,10 @@
    "Password to use when connecting to server. If password is not given"
    " it's solicited on the tty.", (uchar**) &opt_password,(uchar**) &opt_password,
    0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0,
+   GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection or 0 for default to, in "
    "order of preference, my.cnf, $MYSQL_TCP_PORT, "
 #if MYSQL_PORT_DEFAULT == 0
@@ -290,7 +298,7 @@
   DBUG_ENTER("run_tool");
   DBUG_PRINT("enter", ("tool_path: %s", tool_path));
 
-  if (init_dynamic_string(&ds_cmdline, "", FN_REFLEN, FN_REFLEN))
+  if (init_dynamic_string(&ds_cmdline, IF_WIN("\"", ""), FN_REFLEN, FN_REFLEN))
     die("Out of memory");
 
   dynstr_append_os_quoted(&ds_cmdline, tool_path, NullS);
@@ -310,6 +318,10 @@
 
   va_end(args);
 
+#ifdef __WIN__
+  dynstr_append(&ds_cmdline, "\"");
+#endif
+
   DBUG_PRINT("info", ("Running: %s", ds_cmdline.str));
   ret= run_command(ds_cmdline.str, ds_res);
   DBUG_PRINT("exit", ("ret: %d", ret));
@@ -329,11 +341,13 @@
 {
   my_bool ret;
   DBUG_ENTER("get_full_path_to_executable");
-
+#ifdef __WIN__
+  ret= (GetModuleFileName(NULL, path, FN_REFLEN) == 0);
+#else
   /* my_readlink returns 0 if a symlink was read */
   ret= (my_readlink(path, "/proc/self/exe", MYF(0)) != 0);
   /* Might also want to try with /proc/$$/exe if the above fails */
-
+#endif
   DBUG_PRINT("exit", ("path: %s", path));
   DBUG_RETURN(ret);
 }
@@ -422,7 +436,7 @@
                &ds_tmp, /* Get output from command, discard*/
                "--help",
                "2>&1",
-               "> /dev/null",
+               IF_WIN("> NUL", "> /dev/null"),
                NULL))
     die("Can't execute '%s'", tool_path);
 
@@ -735,6 +749,9 @@
 int main(int argc, char **argv)
 {
   MY_INIT(argv[0]);
+#ifdef __NETWARE__
+  setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+#endif
 
   if (init_dynamic_string(&ds_args, "", 512, 256))
     die("Out of memory");
@@ -761,10 +778,10 @@
   dynstr_append(&ds_args, " ");
 
   /* Find mysql */
-  find_tool(mysql_path, "mysql");
+  find_tool(mysql_path, IF_WIN("mysql.exe", "mysql"));
 
   /* Find mysqlcheck */
-  find_tool(mysqlcheck_path, "mysqlcheck");
+  find_tool(mysqlcheck_path, IF_WIN("mysqlcheck.exe", "mysqlcheck"));
 
   /*
     Read the mysql_upgrade_info file to check if mysql_upgrade

=== modified file 'client/mysqladmin.cc'
--- client/mysqladmin.cc	2008-06-30 01:11:33 +0000
+++ client/mysqladmin.cc	2008-06-25 05:29:13 +0000
@@ -127,6 +127,10 @@
 
 static struct my_option my_long_options[] =
 {
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"count", 'c',
    "Number of iterations to make. This works with -i (--sleep) only.",
    (uchar**) &nr_iterations, (uchar**) &nr_iterations, 0, GET_UINT,
@@ -163,6 +167,10 @@
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's asked from the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection or 0 for default to, in "
    "order of preference, my.cnf, $MYSQL_TCP_PORT, "
 #if MYSQL_PORT_DEFAULT == 0
@@ -234,6 +242,11 @@
   int error = 0;
 
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'c':
     opt_count_iterations= 1;
     break;
@@ -254,6 +267,11 @@
   case 's':
     option_silent++;
     break;
+  case 'W':
+#ifdef __WIN__
+    opt_protocol = MYSQL_PROTOCOL_PIPE;
+#endif
+    break;
   case '#':
     DBUG_PUSH(argument ? argument : "d:t:o,/tmp/mysqladmin.trace");
     break;
@@ -836,6 +854,12 @@
         char *pw= argv[1];
         bool old= (find_type(argv[0], &command_typelib, 2) ==
                    ADMIN_OLD_PASSWORD);
+#ifdef __WIN__
+        uint pw_len= strlen(pw);
+        if (pw_len > 1 && pw[0] == '\'' && pw[pw_len-1] == '\'')
+          printf("Warning: single quotes were not trimmed from the password by"
+                 " your command\nline client, as you might have expected.\n");
+#endif
         /*
            If we don't already know to use an old-style password, see what
            the server is using
@@ -988,6 +1012,7 @@
 {
   printf("%s  Ver %s Distrib %s, for %s on %s\n",my_progname,ADMIN_VERSION,
 	 MYSQL_SERVER_VERSION,SYSTEM_TYPE,MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 }
 
 

=== modified file 'client/mysqlbinlog.cc'
--- client/mysqlbinlog.cc	2008-06-30 01:11:33 +0000
+++ client/mysqlbinlog.cc	2008-06-25 05:29:13 +0000
@@ -924,6 +924,10 @@
 {
   {"help", '?', "Display this help and exit.",
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"base64-output", OPT_BASE64_OUTPUT_MODE,
    "Determine when the output statements should be base64-encoded BINLOG "
    "statements: 'never' disables it and works only for binlogs without "
@@ -1150,6 +1154,7 @@
 static void print_version()
 {
   printf("%s Ver 3.3 for %s at %s\n", my_progname, SYSTEM_TYPE, MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 }
 
 
@@ -1199,6 +1204,11 @@
 {
   bool tty_password=0;
   switch (optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
 #ifndef DBUG_OFF
   case '#':
     DBUG_PUSH(argument ? argument : default_dbug_option);
@@ -1812,6 +1822,22 @@
   }
   else
   {
+    /* read from stdin */
+    /*
+      Windows opens stdin in text mode by default. Certain characters
+      such as CTRL-Z are interpeted as events and the read() method
+      will stop. CTRL-Z is the EOF marker in Windows. to get past this
+      you have to open stdin in binary mode. Setmode() is used to set
+      stdin in binary mode. Errors on setting this mode result in 
+      halting the function and printing an error message to stderr.
+    */
+#if defined (__WIN__) || (_WIN64)
+    if (_setmode(fileno(stdin), O_BINARY) == -1)
+    {
+      error("Could not set binary mode on stdin.");
+      return ERROR_STOP;
+    }
+#endif 
     if (init_io_cache(file, fileno(stdin), 0, READ_CACHE, (my_off_t) 0,
 		      0, MYF(MY_WME | MY_NABP | MY_DONT_CHECK_FILESIZE)))
     {

=== modified file 'client/mysqlcheck.c'
--- client/mysqlcheck.c	2008-06-30 01:11:33 +0000
+++ client/mysqlcheck.c	2008-06-25 05:29:13 +0000
@@ -63,6 +63,10 @@
    "Instead of issuing one query for each table, use one query per database, naming all tables in the database in a comma-separated list.",
    (uchar**) &opt_all_in_1, (uchar**) &opt_all_in_1, 0, GET_BOOL, NO_ARG, 0, 0, 0,
    0, 0, 0},
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"auto-repair", OPT_AUTO_REPAIR,
    "If a checked table is corrupted, automatically fix it. Repairing will be done after all tables have been checked, if corrupted ones were found.",
    (uchar**) &opt_auto_repair, (uchar**) &opt_auto_repair, 0, GET_BOOL, NO_ARG, 0,
@@ -133,6 +137,10 @@
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's solicited on the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection or 0 for default to, in "
    "order of preference, my.cnf, $MYSQL_TCP_PORT, "
 #if MYSQL_PORT_DEFAULT == 0
@@ -206,6 +214,7 @@
 {
   printf("%s  Ver %s Distrib %s, for %s (%s)\n", my_progname, CHECK_VERSION,
    MYSQL_SERVER_VERSION, SYSTEM_TYPE, MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 } /* print_version */
 
 
@@ -243,6 +252,11 @@
 	       char *argument)
 {
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'a':
     what_to_do = DO_ANALYZE;
     break;
@@ -294,6 +308,11 @@
     what_to_do= DO_CHECK;
     opt_upgrade= 1;
     break;
+  case 'W':
+#ifdef __WIN__
+    opt_protocol = MYSQL_PROTOCOL_PIPE;
+#endif
+    break;
   case '#':
     DBUG_PUSH(argument ? argument : "d:t:o");
     debug_check_flag= 1;

=== modified file 'client/mysqldump.c'
--- client/mysqldump.c	2008-06-30 01:11:33 +0000
+++ client/mysqldump.c	2008-06-25 05:29:13 +0000
@@ -213,6 +213,10 @@
    "Adds 'STOP SLAVE' prior to 'CHANGE MASTER' and 'START SLAVE' to bottom of dump.",
    (uchar**) &opt_slave_apply, (uchar**) &opt_slave_apply, 0, GET_BOOL, NO_ARG,
    0, 0, 0, 0, 0, 0},
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"character-sets-dir", OPT_CHARSETS_DIR,
    "Directory where character sets are.", (uchar**) &charsets_dir,
    (uchar**) &charsets_dir, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
@@ -400,6 +404,10 @@
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's solicited on the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection.", (uchar**) &opt_mysql_port,
    (uchar**) &opt_mysql_port, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0,
    0},
@@ -551,6 +559,7 @@
 {
   printf("%s  Ver %s Distrib %s, for %s (%s)\n",my_progname,DUMP_VERSION,
          MYSQL_SERVER_VERSION,SYSTEM_TYPE,MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 } /* print_version */
 
 
@@ -560,6 +569,7 @@
   printf("OR     %s [OPTIONS] --databases [OPTIONS] DB1 [DB2 DB3...]\n",
          my_progname);
   printf("OR     %s [OPTIONS] --all-databases [OPTIONS]\n", my_progname);
+  NETWARE_SET_SCREEN_MODE(1);
 }
 
 
@@ -702,6 +712,11 @@
                char *argument)
 {
   switch (optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'p':
     if (argument)
     {
@@ -721,6 +736,11 @@
                                     MYF(MY_WME))))
       exit(1);
     break;
+  case 'W':
+#ifdef __WIN__
+    opt_protocol= MYSQL_PROTOCOL_PIPE;
+#endif
+    break;
   case 'N':
     opt_set_charset= 0;
     break;

=== modified file 'client/mysqlimport.c'
--- client/mysqlimport.c	2008-06-30 01:11:33 +0000
+++ client/mysqlimport.c	2008-06-25 05:29:13 +0000
@@ -67,6 +67,10 @@
 
 static struct my_option my_long_options[] =
 {
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"character-sets-dir", OPT_CHARSETS_DIR,
    "Directory where character sets are.", (uchar**) &charsets_dir,
    (uchar**) &charsets_dir, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
@@ -128,6 +132,10 @@
   {"password", 'p',
    "Password to use when connecting to server. If password is not given it's asked from the tty.",
    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection or 0 for default to, in "
    "order of preference, my.cnf, $MYSQL_TCP_PORT, "
 #if MYSQL_PORT_DEFAULT == 0
@@ -176,6 +184,7 @@
 {
   printf("%s  Ver %s Distrib %s, for %s (%s)\n" ,my_progname,
 	  IMPORT_VERSION, MYSQL_SERVER_VERSION,SYSTEM_TYPE,MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 }
 
 
@@ -204,6 +213,11 @@
 	       char *argument)
 {
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'p':
     if (argument)
     {
@@ -218,6 +232,12 @@
     else
       tty_password= 1;
     break;
+#ifdef __WIN__
+  case 'W':
+    opt_protocol = MYSQL_PROTOCOL_PIPE;
+    opt_local_file=1;
+    break;
+#endif
   case OPT_MYSQL_PROTOCOL:
     opt_protocol= find_type_or_exit(argument, &sql_protocol_typelib,
                                     opt->name);

=== modified file 'client/mysqlshow.c'
--- client/mysqlshow.c	2008-06-30 01:11:33 +0000
+++ client/mysqlshow.c	2008-06-25 05:29:13 +0000
@@ -158,6 +158,10 @@
 
 static struct my_option my_long_options[] =
 {
+#ifdef __NETWARE__
+  {"autoclose", OPT_AUTO_CLOSE, "Auto close the screen on exit for Netware.",
+   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"character-sets-dir", 'c', "Directory where character sets are.",
    (uchar**) &charsets_dir, (uchar**) &charsets_dir, 0, GET_STR, REQUIRED_ARG, 0,
    0, 0, 0, 0, 0},
@@ -200,6 +204,10 @@
    (uchar**) &opt_mysql_port,
    (uchar**) &opt_mysql_port, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0,
    0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+   NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"protocol", OPT_MYSQL_PROTOCOL, "The protocol of connection (tcp,socket,pipe,memory).",
    0, 0, 0, GET_STR,  REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
 #ifdef HAVE_SMEM
@@ -232,6 +240,7 @@
 {
   printf("%s  Ver %s Distrib %s, for %s (%s)\n",my_progname,SHOW_VERSION,
 	 MYSQL_SERVER_VERSION,SYSTEM_TYPE,MACHINE_TYPE);
+  NETWARE_SET_SCREEN_MODE(1);
 }
 
 
@@ -261,6 +270,11 @@
 	       char *argument)
 {
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'v':
     opt_verbose++;
     break;

=== modified file 'client/mysqlslap.c'
--- client/mysqlslap.c	2008-06-30 01:11:33 +0000
+++ client/mysqlslap.c	2008-06-25 05:29:13 +0000
@@ -81,9 +81,17 @@
 #include <signal.h>
 #include <stdarg.h>
 #include <sys/types.h>
+#ifndef __WIN__
 #include <sys/wait.h>
+#endif
 #include <ctype.h>
 
+#ifdef __WIN__
+#define srandom  srand
+#define random   rand
+#define snprintf _snprintf
+#endif
+
 #ifdef HAVE_SMEM 
 static char *shared_memory_base_name=0;
 #endif
@@ -309,6 +317,18 @@
     return s + us;
 }
 
+#ifdef __WIN__
+static int gettimeofday(struct timeval *tp, void *tzp)
+{
+  unsigned int ticks;
+  ticks= GetTickCount();
+  tp->tv_usec= ticks*1000;
+  tp->tv_sec= ticks/1000;
+
+  return 0;
+}
+#endif
+
 int main(int argc, char **argv)
 {
   MYSQL mysql;
@@ -651,6 +671,10 @@
   {"password", 'p',
     "Password to use when connecting to server. If password is not given it's "
       "asked from the tty.", 0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef __WIN__
+  {"pipe", 'W', "Use named pipes to connect to server.", 0, 0, 0, GET_NO_ARG,
+    NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"port", 'P', "Port number to use for connection.", (uchar**) &opt_mysql_port,
     (uchar**) &opt_mysql_port, 0, GET_UINT, REQUIRED_ARG, MYSQL_PORT, 0, 0, 0, 0,
     0},
@@ -745,6 +769,11 @@
 {
   DBUG_ENTER("get_one_option");
   switch(optid) {
+#ifdef __NETWARE__
+  case OPT_AUTO_CLOSE:
+    setscreenmode(SCR_AUTOCLOSE_ON_EXIT);
+    break;
+#endif
   case 'v':
     verbose++;
     break;
@@ -1238,7 +1267,7 @@
 {
   int ho_error;
   char *tmp_string;
-  struct stat sbuf;
+  MY_STAT sbuf;  /* Stat information for the data file */
   option_string *sql_type;
   unsigned int sql_type_count= 0;
 
@@ -1492,7 +1521,7 @@
   }
   else
   {
-    if (create_string && !stat(create_string, &sbuf))
+    if (create_string && my_stat(create_string, &sbuf, MYF(0)))
     {
       File data_file;
       if (!MY_S_ISREG(sbuf.st_mode))
@@ -1529,7 +1558,7 @@
                                                 MYF(MY_ZEROFILL|MY_FAE|MY_WME));
     }
 
-    if (user_supplied_query && !stat(user_supplied_query, &sbuf))
+    if (user_supplied_query && my_stat(user_supplied_query, &sbuf, MYF(0)))
     {
       File data_file;
       if (!MY_S_ISREG(sbuf.st_mode))
@@ -1560,8 +1589,7 @@
     }
   }
 
-  if (user_supplied_pre_statements
-      && !stat(user_supplied_pre_statements, &sbuf))
+  if (user_supplied_pre_statements && my_stat(user_supplied_pre_statements, &sbuf, MYF(0)))
   {
     File data_file;
     if (!MY_S_ISREG(sbuf.st_mode))
@@ -1592,8 +1620,7 @@
                           delimiter[0]);
   }
 
-  if (user_supplied_post_statements
-      && !stat(user_supplied_post_statements, &sbuf))
+  if (user_supplied_post_statements && my_stat(user_supplied_post_statements, &sbuf, MYF(0)))
   {
     File data_file;
     if (!MY_S_ISREG(sbuf.st_mode))

=== modified file 'client/mysqltest.c'
--- client/mysqltest.c	2008-06-30 01:08:38 +0000
+++ client/mysqltest.c	2008-06-25 05:29:13 +0000
@@ -45,8 +45,15 @@
 #ifdef HAVE_SYS_WAIT_H
 #include <sys/wait.h>
 #endif
-
-
+#ifdef __WIN__
+#include <direct.h>
+#endif
+
+
+/* Use cygwin for --exec and --system before 5.0 */
+#if MYSQL_VERSION_ID < 50000
+#define USE_CYGWIN
+#endif
 
 #define MAX_VAR_NAME_LENGTH    256
 #define MAX_COLUMNS            256
@@ -428,6 +435,12 @@
 void str_to_file(const char *fname, char *str, int size);
 void str_to_file2(const char *fname, char *str, int size, my_bool append);
 
+#ifdef __WIN__
+void free_tmp_sh_file();
+void free_win_path_patterns();
+#endif
+
+
 /* For replace_column */
 static char *replace_column[MAX_COLUMNS];
 static uint max_replace_column= 0;
@@ -925,6 +938,10 @@
   my_free(opt_pass,MYF(MY_ALLOW_ZERO_PTR));
   free_defaults(default_argv);
   free_re();
+#ifdef __WIN__
+  free_tmp_sh_file();
+  free_win_path_patterns();
+#endif
 
   /* Only call mysql_server_end if mysql_server_init has been called */
   if (server_initialized)
@@ -1258,7 +1275,7 @@
   DBUG_ENTER("run_tool");
   DBUG_PRINT("enter", ("tool_path: %s", tool_path));
 
-  if (init_dynamic_string(&ds_cmdline, "", FN_REFLEN, FN_REFLEN))
+  if (init_dynamic_string(&ds_cmdline, IF_WIN("\"", ""), FN_REFLEN, FN_REFLEN))
     die("Out of memory");
 
   dynstr_append_os_quoted(&ds_cmdline, tool_path, NullS);
@@ -1278,6 +1295,10 @@
 
   va_end(args);
 
+#ifdef __WIN__
+  dynstr_append(&ds_cmdline, "\"");
+#endif
+
   DBUG_PRINT("info", ("Running: %s", ds_cmdline.str));
   ret= run_command(ds_cmdline.str, ds_res);
   DBUG_PRINT("exit", ("ret: %d", ret));
@@ -1341,6 +1362,9 @@
 "Instead the whole content of the two files was shown for you to diff manually. ;)\n\n"
 "To get a better report you should install 'diff' on your system, which you\n"
 "for example can get from http://www.gnu.org/software/diffutils/diffutils.html\n"
+#ifdef __WIN__
+"or http://gnuwin32.sourceforge.net/packages/diffutils.htm\n"
+#endif
 "\n");
 
       dynstr_append(&ds_tmp, " --- ");
@@ -2238,16 +2262,66 @@
 }
 
 
+#if defined __WIN__
+
+#ifdef USE_CYGWIN
+/* Variables used for temporary sh files used for emulating Unix on Windows */
+char tmp_sh_name[64], tmp_sh_cmd[70];
+#endif
+
+void init_tmp_sh_file()
+{
+#ifdef USE_CYGWIN
+  /* Format a name for the tmp sh file that is unique for this process */
+  my_snprintf(tmp_sh_name, sizeof(tmp_sh_name), "tmp_%d.sh", getpid());
+  /* Format the command to execute in order to run the script */
+  my_snprintf(tmp_sh_cmd, sizeof(tmp_sh_cmd), "sh %s", tmp_sh_name);
+#endif
+}
+
+
+void free_tmp_sh_file()
+{
+#ifdef USE_CYGWIN
+  my_delete(tmp_sh_name, MYF(0));
+#endif
+}
+#endif
+
+
 FILE* my_popen(DYNAMIC_STRING *ds_cmd, const char *mode)
 {
+#if defined __WIN__ && defined USE_CYGWIN
+  /* Dump the command into a sh script file and execute with popen */
+  str_to_file(tmp_sh_name, ds_cmd->str, ds_cmd->length);
+  return popen(tmp_sh_cmd, mode);
+#else
   return popen(ds_cmd->str, mode);
+#endif
 }
 
 
 static void init_builtin_echo(void)
 {
+#ifdef __WIN__
+  size_t echo_length;
+
+  /* Look for "echo.exe" in same dir as mysqltest was started from */
+  dirname_part(builtin_echo, my_progname, &echo_length);
+  fn_format(builtin_echo, ".\\echo.exe",
+            builtin_echo, "", MYF(MY_REPLACE_DIR));
+
+  /* Make sure echo.exe exists */
+  if (access(builtin_echo, F_OK) != 0)
+    builtin_echo[0]= 0;
+  return;
+
+#else
+
   builtin_echo[0]= 0;
   return;
+
+#endif
 }
 
 
@@ -2335,6 +2409,17 @@
     replace(&ds_cmd, "echo", 4, builtin_echo, strlen(builtin_echo));
   }
 
+#ifdef __WIN__
+#ifndef USE_CYGWIN
+  /* Replace /dev/null with NUL */
+  while(replace(&ds_cmd, "/dev/null", 9, "NUL", 3) == 0)
+    ;
+  /* Replace "closed stdout" with non existing output fd */
+  while(replace(&ds_cmd, ">&-", 3, ">&4", 3) == 0)
+    ;
+#endif
+#endif
+
   DBUG_PRINT("info", ("Executing '%s' as '%s'",
                       command->first_argument, ds_cmd.str));
 
@@ -2468,7 +2553,13 @@
 
 int my_system(DYNAMIC_STRING* ds_cmd)
 {
+#if defined __WIN__ && defined USE_CYGWIN
+  /* Dump the command into a sh script file and execute with system */
+  str_to_file(tmp_sh_name, ds_cmd->str, ds_cmd->length);
+  return system(tmp_sh_cmd);
+#else
   return system(ds_cmd->str);
+#endif
 }
 
 
@@ -2498,6 +2589,15 @@
   /* Eval the system command, thus replacing all environment variables */
   do_eval(&ds_cmd, command->first_argument, command->end, !is_windows);
 
+#ifdef __WIN__
+#ifndef USE_CYGWIN
+   /* Replace /dev/null with NUL */
+   while(replace(&ds_cmd, "/dev/null", 9, "NUL", 3) == 0)
+     ;
+#endif
+#endif
+
+
   DBUG_PRINT("info", ("running system command '%s' as '%s'",
                       command->first_argument, ds_cmd.str));
   if (my_system(&ds_cmd))
@@ -5304,6 +5404,125 @@
   }
 }
 
+
+#ifdef __WIN__
+
+DYNAMIC_ARRAY patterns;
+
+/*
+  init_win_path_patterns
+
+  DESCRIPTION
+  Setup string patterns that will be used to detect filenames that
+  needs to be converted from Win to Unix format
+
+*/
+
+void init_win_path_patterns()
+{
+  /* List of string patterns to match in order to find paths */
+  const char* paths[] = { "$MYSQL_TEST_DIR",
+                          "$MYSQL_TMP_DIR",
+                          "$MYSQLTEST_VARDIR",
+                          "./test/" };
+  int num_paths= sizeof(paths)/sizeof(char*);
+  int i;
+  char* p;
+
+  DBUG_ENTER("init_win_path_patterns");
+
+  my_init_dynamic_array(&patterns, sizeof(const char*), 16, 16);
+
+  /* Loop through all paths in the array */
+  for (i= 0; i < num_paths; i++)
+  {
+    VAR* v;
+    if (*(paths[i]) == '$')
+    {
+      v= var_get(paths[i], 0, 0, 0);
+      p= my_strdup(v->str_val, MYF(MY_FAE));
+    }
+    else
+      p= my_strdup(paths[i], MYF(MY_FAE));
+
+    /* Don't insert zero length strings in patterns array */
+    if (strlen(p) == 0)
+    {
+      my_free(p, MYF(0));
+      continue;
+    }
+
+    if (insert_dynamic(&patterns, (uchar*) &p))
+      die(NullS);
+
+    DBUG_PRINT("info", ("p: %s", p));
+    while (*p)
+    {
+      if (*p == '/')
+        *p='\\';
+      p++;
+    }
+  }
+  DBUG_VOID_RETURN;
+}
+
+void free_win_path_patterns()
+{
+  uint i= 0;
+  for (i=0 ; i < patterns.elements ; i++)
+  {
+    const char** pattern= dynamic_element(&patterns, i, const char**);
+    my_free((char*) *pattern, MYF(0));
+  }
+  delete_dynamic(&patterns);
+}
+
+/*
+  fix_win_paths
+
+  DESCRIPTION
+  Search the string 'val' for the patterns that are known to be
+  strings that contain filenames. Convert all \ to / in the
+  filenames that are found.
+
+  Ex:
+  val = 'Error "c:\mysql\mysql-test\var\test\t1.frm" didn't exist'
+  => $MYSQL_TEST_DIR is found by strstr
+  => all \ from c:\mysql\m... until next space is converted into /
+*/
+
+void fix_win_paths(const char *val, int len)
+{
+  uint i;
+  char *p;
+
+  DBUG_ENTER("fix_win_paths");
+  for (i= 0; i < patterns.elements; i++)
+  {
+    const char** pattern= dynamic_element(&patterns, i, const char**);
+    DBUG_PRINT("info", ("pattern: %s", *pattern));
+
+    /* Search for the path in string */
+    while ((p= strstr(val, *pattern)))
+    {
+      DBUG_PRINT("info", ("Found %s in val p: %s", *pattern, p));
+
+      while (*p && !my_isspace(charset_info, *p))
+      {
+        if (*p == '\\')
+          *p= '/';
+        p++;
+      }
+      DBUG_PRINT("info", ("Converted \\ to /, p: %s", p));
+    }
+  }
+  DBUG_PRINT("exit", (" val: %s, len: %d", val, len));
+  DBUG_VOID_RETURN;
+}
+#endif
+
+
+
 /*
   Append the result for one field to the dynamic string ds
 */
@@ -5321,6 +5540,23 @@
     val= "NULL";
     len= 4;
   }
+#ifdef __WIN__
+  else if ((field->type == MYSQL_TYPE_DOUBLE ||
+            field->type == MYSQL_TYPE_FLOAT ) &&
+           field->decimals >= 31)
+  {
+    /* Convert 1.2e+018 to 1.2e+18 and 1.2e-018 to 1.2e-18 */
+    char *start= strchr(val, 'e');
+    if (start && strlen(start) >= 5 &&
+        (start[1] == '-' || start[1] == '+') && start[2] == '0')
+    {
+      start+=2; /* Now points at first '0' */
+      /* Move all chars after the first '0' one step left */
+      memmove(start, start + 1, strlen(start));
+      len--;
+    }
+  }
+#endif
 
   if (!display_result_vertically)
   {
@@ -6531,7 +6767,7 @@
   my_bool q_send_flag= 0, abort_flag= 0;
   uint command_executed= 0, last_command_executed= 0;
   char save_file[FN_REFLEN];
-  struct stat res_info;
+  MY_STAT res_info;
   MY_INIT(argv[0]);
 
   save_file[0]= 0;
@@ -6580,6 +6816,13 @@
   memset(&var_reg, 0, sizeof(var_reg));
 
   init_builtin_echo();
+#ifdef __WIN__
+#ifndef USE_CYGWIN
+  is_windows= 1;
+#endif
+  init_tmp_sh_file();
+  init_win_path_patterns();
+#endif
 
   init_dynamic_string(&ds_res, "", 65536, 65536);
   init_dynamic_string(&ds_progress, "", 0, 2048);
@@ -6999,7 +7242,7 @@
   }
 
   if (!command_executed &&
-      result_file_name && !stat(result_file_name, &res_info))
+      result_file_name && my_stat(result_file_name, &res_info, 0))
   {
     /*
       my_stat() successful on result file. Check if we have not run a
@@ -8365,6 +8608,10 @@
 void replace_dynstr_append_mem(DYNAMIC_STRING *ds,
                                const char *val, int len)
 {
+#ifdef __WIN__
+  fix_win_paths(val, len);
+#endif
+
   if (glob_replace_regex)
   {
     /* Regex replace */

=== modified file 'configure.in'
--- configure.in	2008-06-29 23:41:16 +0000
+++ configure.in	2008-06-28 06:45:02 +0000
@@ -1842,7 +1842,7 @@
  unittest/Makefile unittest/mytap/Makefile unittest/mytap/t/Makefile dnl
  unittest/mysys/Makefile unittest/examples/Makefile dnl
  strings/Makefile regex/Makefile storage/Makefile dnl
- vio/Makefile dnl
+ BUILD/Makefile vio/Makefile dnl
  libmysql/Makefile libmysql_r/Makefile client/Makefile dnl
  sql/Makefile sql/share/Makefile dnl
  sql/sql_builtin.cc sql-common/Makefile dnl

=== modified file 'extra/comp_err.c'
--- extra/comp_err.c	2008-06-30 00:30:38 +0000
+++ extra/comp_err.c	2008-06-25 05:29:13 +0000
@@ -269,7 +269,7 @@
   struct languages *tmp_lang;
   struct errors *tmp_error;
 
-  struct stat stat_info;
+  MY_STAT stat_info;
   DBUG_ENTER("create_sys_files");
 
   /*
@@ -288,7 +288,7 @@
 
     outfile_end= strxmov(outfile, DATADIRECTORY, 
                          tmp_lang->lang_long_name, NullS);
-    if (stat(outfile, &stat_info))
+    if (!my_stat(outfile, &stat_info,MYF(0)))
     {
       if (my_mkdir(outfile, 0777,MYF(0)) < 0)
       {

=== modified file 'include/my_dir.h'
--- include/my_dir.h	2008-06-30 00:30:38 +0000
+++ include/my_dir.h	2008-06-25 05:29:13 +0000
@@ -94,6 +94,8 @@
 
 extern MY_DIR *my_dir(const char *path,myf MyFlags);
 extern void my_dirend(MY_DIR *buffer);
+extern MY_STAT *my_stat(const char *path, MY_STAT *stat_area, myf my_flags);
+extern int my_fstat(int filenr, MY_STAT *stat_area, myf MyFlags);
 
 #endif /* MY_DIR_H */
 

=== modified file 'include/my_sys.h'
--- include/my_sys.h	2008-06-30 00:50:44 +0000
+++ include/my_sys.h	2008-06-25 05:29:13 +0000
@@ -881,6 +881,8 @@
 int my_getpagesize(void);
 #endif
 
+int my_msync(int, void *, size_t, int);
+
 /* character sets */
 extern uint get_charset_number(const char *cs_name, uint cs_flags);
 extern uint get_collation_number(const char *name);

=== modified file 'mysys/Makefile.am'
--- mysys/Makefile.am	2008-06-30 00:50:44 +0000
+++ mysys/Makefile.am	2008-06-28 06:00:33 +0000
@@ -21,7 +21,7 @@
 pkglib_LIBRARIES =	libmysys.a
 LDADD =			libmysys.a $(top_builddir)/strings/libmystrings.a $(top_builddir)/dbug/libdbug.a
 noinst_HEADERS =	mysys_priv.h my_static.h my_handler_errors.h
-libmysys_a_SOURCES =    my_init.c my_getwd.c mf_getdate.c \
+libmysys_a_SOURCES =    my_init.c my_getwd.c mf_getdate.c my_mmap.c \
 			mf_path.c mf_loadpath.c my_file.c \
 			my_open.c my_create.c my_dup.c my_seek.c my_read.c \
 			my_pread.c my_write.c my_getpagesize.c \

=== modified file 'mysys/charset.c'
--- mysys/charset.c	2008-06-30 00:30:38 +0000
+++ mysys/charset.c	2008-06-25 05:29:13 +0000
@@ -355,9 +355,9 @@
   uchar *buf;
   int  fd;
   uint len, tmp_len;
-  struct stat stat_info;
+  MY_STAT stat_info;
   
-  if (stat(filename, &stat_info) ||
+  if (!my_stat(filename, &stat_info, MYF(myflags)) ||
        ((len= (uint)stat_info.st_size) > MY_MAX_ALLOWED_BUF) ||
        !(buf= (uchar*) my_malloc(len,myflags)))
     return TRUE;

=== modified file 'mysys/default.c'
--- mysys/default.c	2008-06-30 00:30:38 +0000
+++ mysys/default.c	2008-06-25 05:29:13 +0000
@@ -610,8 +610,8 @@
   }
   fn_format(name,name,"","",4);
   {
-    struct stat stat_info;
-    if (stat(name,&stat_info))
+    MY_STAT stat_info;
+    if (!my_stat(name,&stat_info,MYF(0)))
       return 1;
     /*
       Ignore world-writable regular files.

=== modified file 'mysys/default_modify.c'
--- mysys/default_modify.c	2008-06-30 00:30:38 +0000
+++ mysys/default_modify.c	2008-06-25 05:29:13 +0000
@@ -61,7 +61,7 @@
                          const char *section_name, int remove_option)
 {
   FILE *cnf_file;
-  struct stat file_stat;
+  MY_STAT file_stat;
   char linebuff[BUFF_SIZE], *src_ptr, *dst_ptr, *file_buffer;
   size_t opt_len= 0, optval_len= 0, sect_len;
   uint nr_newlines= 0, buffer_size;
@@ -74,7 +74,8 @@
   if (!(cnf_file= my_fopen(file_location, O_RDWR | O_BINARY, MYF(0))))
     DBUG_RETURN(2);
 
-  if (fstat(fileno(cnf_file), &file_stat))
+  /* my_fstat doesn't use the flag parameter */
+  if (my_fstat(fileno(cnf_file), &file_stat, MYF(0)))
     goto malloc_err;
 
   if (option && option_value)

=== modified file 'mysys/my_copy.c'
--- mysys/my_copy.c	2008-06-30 00:30:38 +0000
+++ mysys/my_copy.c	2008-06-25 05:29:13 +0000
@@ -55,18 +55,18 @@
   int create_flag;
   File from_file,to_file;
   uchar buff[IO_SIZE];
-  struct stat stat_buff,new_stat_buff;
+  MY_STAT stat_buff,new_stat_buff;
   DBUG_ENTER("my_copy");
   DBUG_PRINT("my",("from %s to %s MyFlags %d", from, to, MyFlags));
 
   from_file=to_file= -1;
   DBUG_ASSERT(!(MyFlags & (MY_FNABP | MY_NABP))); /* for my_read/my_write */
   if (MyFlags & MY_HOLD_ORIGINAL_MODES)		/* Copy stat if possible */
-    new_file_stat= test(!stat((char*) to, &new_stat_buff));
+    new_file_stat= test(my_stat((char*) to, &new_stat_buff, MYF(0)));
 
   if ((from_file=my_open(from,O_RDONLY | O_SHARE,MyFlags)) >= 0)
   {
-    if (stat(from, &stat_buff))
+    if (!my_stat(from, &stat_buff, MyFlags))
     {
       my_errno=errno;
       goto err;

=== modified file 'mysys/my_lib.c'
--- mysys/my_lib.c	2008-06-30 00:30:38 +0000
+++ mysys/my_lib.c	2008-06-25 05:29:13 +0000
@@ -138,13 +138,13 @@
     
     if (MyFlags & MY_WANT_STAT)
     {
-      if (!(finfo.mystat= (struct stat*)alloc_root(names_storage, 
-                                               sizeof(struct stat))))
+      if (!(finfo.mystat= (MY_STAT*)alloc_root(names_storage, 
+                                               sizeof(MY_STAT))))
         goto error;
       
-      bzero(finfo.mystat, sizeof(struct stat));
+      bzero(finfo.mystat, sizeof(MY_STAT));
       VOID(strmov(tmp_file,dp->d_name));
-      VOID(stat(tmp_path, finfo.mystat));
+      VOID(my_stat(tmp_path, finfo.mystat, MyFlags));
       if (!(finfo.mystat->st_mode & MY_S_IREAD))
         continue;
     }
@@ -208,3 +208,44 @@
   return dst;
 } /* directory_file_name */
 
+
+/****************************************************************************
+** File status
+** Note that MY_STAT is assumed to be same as struct stat
+****************************************************************************/ 
+
+int my_fstat(int Filedes, MY_STAT *stat_area,
+             myf MyFlags __attribute__((unused)))
+{
+  DBUG_ENTER("my_fstat");
+  DBUG_PRINT("my",("fd: %d  MyFlags: %d", Filedes, MyFlags));
+  DBUG_RETURN(fstat(Filedes, (struct stat *) stat_area));
+}
+
+
+MY_STAT *my_stat(const char *path, MY_STAT *stat_area, myf my_flags)
+{
+  int m_used;
+  DBUG_ENTER("my_stat");
+  DBUG_PRINT("my", ("path: '%s'  stat_area: 0x%lx  MyFlags: %d", path,
+                    (long) stat_area, my_flags));
+
+  if ((m_used= (stat_area == NULL)))
+    if (!(stat_area = (MY_STAT *) my_malloc(sizeof(MY_STAT), my_flags)))
+      goto error;
+  if (! stat((char *) path, (struct stat *) stat_area) )
+    DBUG_RETURN(stat_area);
+
+  DBUG_PRINT("error",("Got errno: %d from stat", errno));
+  my_errno= errno;
+  if (m_used)					/* Free if new area */
+    my_free((uchar*) stat_area,MYF(0));
+
+error:
+  if (my_flags & (MY_FAE+MY_WME))
+  {
+    my_error(EE_STAT, MYF(ME_BELL+ME_WAITTANG),path,my_errno);
+    DBUG_RETURN((MY_STAT *) NULL);
+  }
+  DBUG_RETURN((MY_STAT *) NULL);
+} /* my_stat */

=== added file 'mysys/my_mmap.c'
--- mysys/my_mmap.c	1970-01-01 00:00:00 +0000
+++ mysys/my_mmap.c	2008-06-25 05:29:13 +0000
@@ -0,0 +1,32 @@
+/* Copyright (C) 2000-2003 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#include "mysys_priv.h"
+
+#ifdef HAVE_SYS_MMAN_H
+
+/*
+  system msync() only syncs mmap'ed area to fs cache.
+  fsync() is required to really sync to disc
+*/
+int my_msync(int fd, void *addr, size_t len, int flags)
+{
+  msync(addr, len, flags);
+  return my_sync(fd, MYF(0));
+}
+#else
+#warning "no mmap!"
+#endif
+

=== modified file 'sql/discover.cc'
--- sql/discover.cc	2008-06-30 00:30:38 +0000
+++ sql/discover.cc	2008-06-25 05:29:13 +0000
@@ -50,7 +50,7 @@
   File	 file;
   size_t read_len;
   uchar *read_data;
-  struct stat state;  
+  MY_STAT state;  
   DBUG_ENTER("readfrm");
   DBUG_PRINT("enter",("name: '%s'",name));
   
@@ -65,7 +65,7 @@
   
   // Get length of file
   error= 2;
-  if (fstat(file, &state))
+  if (my_fstat(file, &state, MYF(0)))
     goto err;
   read_len= state.st_size;  
 

=== modified file 'sql/item_strfunc.cc'
--- sql/item_strfunc.cc	2008-06-30 00:30:38 +0000
+++ sql/item_strfunc.cc	2008-06-25 05:29:13 +0000
@@ -2483,14 +2483,14 @@
 }
 
 
-#include <my_dir.h>
+#include <my_dir.h>				// For my_stat
 
 String *Item_load_file::val_str(String *str)
 {
   DBUG_ASSERT(fixed == 1);
   String *file_name;
   File file;
-  struct stat stat_info;
+  MY_STAT stat_info;
   char path[FN_REFLEN];
   DBUG_ENTER("load_file");
 
@@ -2505,7 +2505,7 @@
       strncmp(opt_secure_file_priv, path, strlen(opt_secure_file_priv)))
     goto err;
 
-  if (stat(path, &stat_info))
+  if (!my_stat(path, &stat_info, MYF(0)))
     goto err;
 
   if (!(stat_info.st_mode & S_IROTH))

=== modified file 'sql/log.cc'
--- sql/log.cc	2008-06-30 00:50:44 +0000
+++ sql/log.cc	2008-06-29 18:24:06 +0000
@@ -2458,7 +2458,7 @@
     LOG_INFO_EOF		to_log not found
     LOG_INFO_EMFILE             too many files opened
     LOG_INFO_FATAL              if any other than ENOENT error from
-                                stat() or my_delete()
+                                my_stat() or my_delete()
 */
 
 int MYSQL_BIN_LOG::purge_logs(const char *to_log, 
@@ -2488,10 +2488,10 @@
   while ((strcmp(to_log,log_info.log_file_name) || (exit_loop=included)) &&
          !log_in_use(log_info.log_file_name))
   {
-    struct stat s;
-    if (stat(log_info.log_file_name, &s))
+    MY_STAT s;
+    if (!my_stat(log_info.log_file_name, &s, MYF(0)))
     {
-      if (errno == ENOENT) 
+      if (my_errno == ENOENT) 
       {
         /*
           It's not fatal if we can't stat a log file that does not exist;
@@ -2500,7 +2500,7 @@
         push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
                             ER_LOG_PURGE_NO_FILE, ER(ER_LOG_PURGE_NO_FILE),
                             log_info.log_file_name);
-        sql_print_information("Failed to execute stat on file '%s'",
+        sql_print_information("Failed to execute my_stat on file '%s'",
 			      log_info.log_file_name);
         my_errno= 0;
       }
@@ -2597,14 +2597,14 @@
   @retval
     LOG_INFO_PURGE_NO_ROTATE	Binary file that can't be rotated
     LOG_INFO_FATAL              if any other than ENOENT error from
-                                stat() or my_delete()
+                                my_stat() or my_delete()
 */
 
 int MYSQL_BIN_LOG::purge_logs_before_date(time_t purge_time)
 {
   int error;
   LOG_INFO log_info;
-  struct stat stat_area;
+  MY_STAT stat_area;
 
   DBUG_ENTER("purge_logs_before_date");
 
@@ -2621,9 +2621,9 @@
   while (strcmp(log_file_name, log_info.log_file_name) &&
 	 !log_in_use(log_info.log_file_name))
   {
-    if (stat(log_info.log_file_name, &stat_area))
+    if (!my_stat(log_info.log_file_name, &stat_area, MYF(0)))
     {
-      if (errno == ENOENT) 
+      if (my_errno == ENOENT) 
       {
         /*
           It's not fatal if we can't stat a log file that does not exist.
@@ -2631,7 +2631,7 @@
         push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
                             ER_LOG_PURGE_NO_FILE, ER(ER_LOG_PURGE_NO_FILE),
                             log_info.log_file_name);
-	sql_print_information("Failed to execute stat on file '%s'",
+	sql_print_information("Failed to execute my_stat on file '%s'",
 			      log_info.log_file_name);
         my_errno= 0;
       }
@@ -4246,8 +4246,7 @@
 
   memcpy(data, tc_log_magic, sizeof(tc_log_magic));
   data[sizeof(tc_log_magic)]= (uchar)total_ha_2pc;
-  msync(data, tc_log_page_size, MS_SYNC);
-  my_sync(fd, MYF(0));
+  my_msync(fd, data, tc_log_page_size, MS_SYNC);
   inited=5;
 
   pthread_mutex_init(&LOCK_sync,    MY_MUTEX_INIT_FAST);
@@ -4452,9 +4451,7 @@
     sit down and relax - this can take a while...
     note - no locks are held at this point
   */
-  err= msync(syncing->start, 1, MS_SYNC);
-  if(err==0)
-    err= my_sync(fd, MYF(0));
+  err= my_msync(fd, syncing->start, 1, MS_SYNC);
 
   /* page is synced. let's move it to the pool */
   pthread_mutex_lock(&LOCK_pool);

=== modified file 'sql/my_lock.c'
--- sql/my_lock.c	2008-06-30 01:17:15 +0000
+++ sql/my_lock.c	2008-06-25 05:29:13 +0000
@@ -13,6 +13,10 @@
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
+#if defined(__NETWARE__)
+#include "../mysys/my_lock.c"
+#else
+
 #undef MAP_TO_USE_RAID			/* Avoid RAID mappings */
 #include <my_global.h>
 #include <my_sys.h>
@@ -71,4 +75,4 @@
   DBUG_PRINT("error",("errno: %d",errno));
   DBUG_RETURN(-1);
 }
-
+#endif

=== modified file 'sql/mysql_priv.h'
--- sql/mysql_priv.h	2008-06-29 19:19:20 +0000
+++ sql/mysql_priv.h	2008-06-29 18:24:06 +0000
@@ -1797,14 +1797,16 @@
 extern int bootstrap_error;
 extern FILE *stderror_file;
 extern pthread_key(MEM_ROOT**,THR_MALLOC);
-extern pthread_mutex_t LOCK_mysql_create_db,LOCK_open, LOCK_lock_db,
+extern pthread_mutex_t LOCK_mysql_create_db,LOCK_Acl,LOCK_open, LOCK_lock_db,
        LOCK_thread_count,LOCK_mapped_file,LOCK_user_locks, LOCK_status,
        LOCK_error_log, LOCK_uuid_generator,
-       LOCK_crypt, LOCK_timezone,
+       LOCK_delayed_status, LOCK_delayed_create, LOCK_crypt, LOCK_timezone,
        LOCK_slave_list, LOCK_active_mi, LOCK_manager, LOCK_global_read_lock,
        LOCK_global_system_variables, LOCK_user_conn,
+       LOCK_prepared_stmt_count,
        LOCK_bytes_sent, LOCK_bytes_received, LOCK_connection_count;
 extern pthread_mutex_t LOCK_server_started;
+extern pthread_cond_t COND_server_started;
 extern rw_lock_t LOCK_sys_init_connect, LOCK_sys_init_slave;
 extern rw_lock_t LOCK_system_variables_hash;
 extern pthread_cond_t COND_refresh, COND_thread_count, COND_manager;

=== modified file 'sql/mysqld.cc'
--- sql/mysqld.cc	2008-06-30 00:30:38 +0000
+++ sql/mysqld.cc	2008-06-29 18:24:06 +0000
@@ -53,6 +53,13 @@
 #define MAX_MEM_TABLE_SIZE ~(ulonglong) 0
 #endif
 
+/* stack traces are only supported on linux intel */
+#if defined(__linux__)  && defined(__i386__) && defined(USE_PSTACK)
+#define	HAVE_STACK_TRACE_ON_SEGV
+#include "../pstack/pstack.h"
+char pstack_file_name[80];
+#endif /* __linux__ */
+
 /* We have HAVE_purify below as this speeds up the shutdown of MySQL */
 
 #if defined(HAVE_DEC_3_2_THREADS) || defined(SIGNALS_DONT_BREAK_READ) || defined(HAVE_purify) && defined(__linux__)
@@ -336,6 +343,22 @@
 ulong binlog_cache_use= 0, binlog_cache_disk_use= 0;
 ulong max_connections, max_connect_errors;
 uint  max_user_connections= 0;
+/**
+  Limit of the total number of prepared statements in the server.
+  Is necessary to protect the server against out-of-memory attacks.
+*/
+ulong max_prepared_stmt_count;
+/**
+  Current total number of prepared statements in the server. This number
+  is exact, and therefore may not be equal to the difference between
+  `com_stmt_prepare' and `com_stmt_close' (global status variables), as
+  the latter ones account for all registered attempts to prepare
+  a statement (including unsuccessful ones).  Prepared statements are
+  currently connection-local: if the same SQL query text is prepared in
+  two different connections, this counts as two distinct prepared
+  statements.
+*/
+ulong prepared_stmt_count=0;
 ulong thread_id=1L,current_pid;
 ulong slow_launch_threads = 0, sync_binlog_period;
 ulong expire_logs_days = 0;
@@ -446,7 +469,7 @@
 pthread_mutex_t LOCK_mysql_create_db, LOCK_open, LOCK_thread_count,
 		LOCK_mapped_file, LOCK_status, LOCK_global_read_lock,
 		LOCK_error_log, LOCK_uuid_generator,
-		LOCK_crypt,
+		LOCK_crypt, LOCK_bytes_sent, LOCK_bytes_received,
 	        LOCK_global_system_variables,
 		LOCK_user_conn, LOCK_slave_list, LOCK_active_mi,
                 LOCK_connection_count;
@@ -968,10 +991,14 @@
   (void) pthread_mutex_destroy(&LOCK_error_log);
   (void) pthread_mutex_destroy(&LOCK_manager);
   (void) pthread_mutex_destroy(&LOCK_crypt);
+  (void) pthread_mutex_destroy(&LOCK_bytes_sent);
+  (void) pthread_mutex_destroy(&LOCK_bytes_received);
   (void) pthread_mutex_destroy(&LOCK_user_conn);
   (void) pthread_mutex_destroy(&LOCK_connection_count);
+#ifdef HAVE_REPLICATION
   (void) pthread_mutex_destroy(&LOCK_rpl_status);
   (void) pthread_cond_destroy(&COND_rpl_status);
+#endif
   (void) pthread_mutex_destroy(&LOCK_active_mi);
   (void) rwlock_destroy(&LOCK_sys_init_connect);
   (void) rwlock_destroy(&LOCK_sys_init_slave);
@@ -2070,12 +2097,14 @@
   {"show_fields",          (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_FIELDS]), SHOW_LONG_STATUS},
   {"show_keys",            (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_KEYS]), SHOW_LONG_STATUS},
   {"show_master_status",   (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_MASTER_STAT]), SHOW_LONG_STATUS},
+  {"show_new_master",      (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_NEW_MASTER]), SHOW_LONG_STATUS},
   {"show_open_tables",     (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_OPEN_TABLES]), SHOW_LONG_STATUS},
   {"show_plugins",         (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_PLUGINS]), SHOW_LONG_STATUS},
   {"show_processlist",     (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_PROCESSLIST]), SHOW_LONG_STATUS},
   {"show_slave_hosts",     (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_SLAVE_HOSTS]), SHOW_LONG_STATUS},
   {"show_slave_status",    (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_SLAVE_STAT]), SHOW_LONG_STATUS},
   {"show_status",          (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_STATUS]), SHOW_LONG_STATUS},
+  {"show_storage_engines", (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_STORAGE_ENGINES]), SHOW_LONG_STATUS},
   {"show_table_status",    (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_TABLE_STATUS]), SHOW_LONG_STATUS},
   {"show_tables",          (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_TABLES]), SHOW_LONG_STATUS},
   {"show_variables",       (char*) offsetof(STATUS_VAR, com_stat[(uint) SQLCOM_SHOW_VARIABLES]), SHOW_LONG_STATUS},
@@ -2445,6 +2474,8 @@
   (void) pthread_mutex_init(&LOCK_error_log,MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_manager,MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_crypt,MY_MUTEX_INIT_FAST);
+  (void) pthread_mutex_init(&LOCK_bytes_sent,MY_MUTEX_INIT_FAST);
+  (void) pthread_mutex_init(&LOCK_bytes_received,MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_user_conn, MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_active_mi, MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_global_system_variables, MY_MUTEX_INIT_FAST);
@@ -2460,8 +2491,10 @@
   (void) pthread_cond_init(&COND_thread_cache,NULL);
   (void) pthread_cond_init(&COND_flush_thread_cache,NULL);
   (void) pthread_cond_init(&COND_manager,NULL);
+#ifdef HAVE_REPLICATION
   (void) pthread_mutex_init(&LOCK_rpl_status, MY_MUTEX_INIT_FAST);
   (void) pthread_cond_init(&COND_rpl_status, NULL);
+#endif
 
   /* Parameter for threads created for connections */
   (void) pthread_attr_init(&connection_attrib);
@@ -2500,7 +2533,9 @@
   randominit(&sql_rand,(ulong) server_start_time,(ulong) server_start_time/2);
   setup_fpu();
   init_thr_lock();
+#ifdef HAVE_REPLICATION
   init_slave_list();
+#endif
 
   /* Setup logs */
 
@@ -2614,6 +2649,7 @@
   DBUG_ASSERT((uint)global_system_variables.binlog_format <=
               array_elements(binlog_format_names)-1);
 
+#ifdef HAVE_REPLICATION
   if (opt_log_slave_updates && replicate_same_server_id)
   {
     sql_print_error("\
@@ -2622,6 +2658,7 @@
 server.");
     unireg_abort(1);
   }
+#endif
 
   if (opt_bin_log)
   {
@@ -2781,12 +2818,14 @@
                                         WRITE_CACHE, 0, max_binlog_size, 0))
     unireg_abort(1);
 
+#ifdef HAVE_REPLICATION
   if (opt_bin_log && expire_logs_days)
   {
     time_t purge_time= server_start_time - expire_logs_days*24*60*60;
     if (purge_time >= 0)
       mysql_bin_log.purge_logs_before_date(purge_time);
   }
+#endif
 
   if (opt_myisam_log)
     (void) mi_log(1);
@@ -3508,10 +3547,12 @@
   {"help", '?', "Display this help and exit.", 
    (uchar**) &opt_help, (uchar**) &opt_help, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
    0, 0},
+#ifdef HAVE_REPLICATION
   {"abort-slave-event-count", OPT_ABORT_SLAVE_EVENT_COUNT,
    "Option used by mysql-test for debugging and testing of replication.",
    (uchar**) &abort_slave_event_count,  (uchar**) &abort_slave_event_count,
    0, GET_INT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+#endif /* HAVE_REPLICATION */
   {"allow-suspicious-udfs", OPT_ALLOW_SUSPICIOUS_UDFS,
    "Allows use of UDFs consisting of only one symbol xxx() "
    "without corresponding xxx_init() or xxx_deinit(). That also means "
@@ -3931,6 +3972,7 @@
   {"skip-thread-priority", OPT_SKIP_PRIOR,
    "Don't give threads different priorities.", 0, 0, 0, GET_NO_ARG, NO_ARG,
    DEFAULT_SKIP_THREAD_PRIORITY, 0, 0, 0, 0, 0},
+#ifdef HAVE_REPLICATION
   {"slave-load-tmpdir", OPT_SLAVE_LOAD_TMPDIR,
    "The location where the slave should put its temporary files when \
 replicating a LOAD DATA INFILE command.",
@@ -3942,14 +3984,17 @@
   {"slave-exec-mode", OPT_SLAVE_EXEC_MODE,
    "Modes for how replication events should be executed.  Legal values are STRICT (default) and IDEMPOTENT. In IDEMPOTENT mode, replication will not stop for operations that are idempotent. In STRICT mode, replication will stop on any unexpected difference between the master and the slave.",
    (uchar**) &slave_exec_mode_str, (uchar**) &slave_exec_mode_str, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+#endif
   {"slow-query-log", OPT_SLOW_LOG,
    "Enable|disable slow query log", (uchar**) &opt_slow_log,
    (uchar**) &opt_slow_log, 0, GET_BOOL, OPT_ARG, 0, 0, 0, 0, 0, 0},
+#ifdef HAVE_REPLICATION
   {"sporadic-binlog-dump-fail", OPT_SPORADIC_BINLOG_DUMP_FAIL,
    "Option used by mysql-test for debugging and testing of replication.",
    (uchar**) &opt_sporadic_binlog_dump_fail,
    (uchar**) &opt_sporadic_binlog_dump_fail, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0,
    0},
+#endif /* HAVE_REPLICATION */
   {"sql-bin-update-same", OPT_SQL_BIN_UPDATE_SAME,
    "The update log is deprecated since version 5.0, is replaced by the binary \
 log and this option does nothing anymore.",
@@ -4155,6 +4200,10 @@
     (uchar**) &global_system_variables.max_length_for_sort_data,
     (uchar**) &max_system_variables.max_length_for_sort_data, 0, GET_ULONG,
     REQUIRED_ARG, 1024, 4, 8192*1024L, 0, 1, 0},
+  {"max_prepared_stmt_count", OPT_MAX_PREPARED_STMT_COUNT,
+   "Maximum number of prepared statements in the server.",
+   (uchar**) &max_prepared_stmt_count, (uchar**) &max_prepared_stmt_count,
+   0, GET_ULONG, REQUIRED_ARG, 16382, 0, 1*1024*1024, 0, 1, 0},
   {"max_relay_log_size", OPT_MAX_RELAY_LOG_SIZE,
    "If non-zero: relay log will be rotated automatically when the size exceeds this value; if zero (the default): when the size exceeds max_binlog_size. 0 excepted, the minimum value for this variable is 4096.",
    (uchar**) &max_relay_log_size, (uchar**) &max_relay_log_size, 0, GET_ULONG,
@@ -4313,6 +4362,7 @@
    (uchar**) &global_system_variables.read_buff_size,
    (uchar**) &max_system_variables.read_buff_size,0, GET_ULONG, REQUIRED_ARG,
    128*1024L, IO_SIZE*2+MALLOC_OVERHEAD, INT_MAX32, MALLOC_OVERHEAD, IO_SIZE, 0},
+#ifdef HAVE_REPLICATION
   {"relay_log_purge", OPT_RELAY_LOG_PURGE,
    "0 = do not purge relay logs. 1 = purge them as soon as they are no more needed.",
    (uchar**) &relay_log_purge,
@@ -4342,6 +4392,7 @@
    "Allow slave to batch requests.",
    (uchar**) &slave_allow_batching, (uchar**) &slave_allow_batching,
    0, GET_BOOL, NO_ARG, 0, 0, 1, 0, 1, 0},
+#endif /* HAVE_REPLICATION */
   {"slow_launch_time", OPT_SLOW_LAUNCH_TIME,
    "If creating the thread takes longer than this value (in seconds), the Slow_launch_threads counter will be incremented.",
    (uchar**) &slow_launch_time, (uchar**) &slow_launch_time, 0, GET_ULONG,
@@ -4446,6 +4497,7 @@
   return 0;
 }
 
+#ifdef HAVE_REPLICATION
 static int show_slave_running(THD *thd, SHOW_VAR *var, char *buff)
 {
   var->type= SHOW_MY_BOOL;
@@ -4511,6 +4563,8 @@
 }
 
 
+#endif /* HAVE_REPLICATION */
+
 static int show_open_tables(THD *thd, SHOW_VAR *var, char *buff)
 {
   var->type= SHOW_LONG;
@@ -4583,10 +4637,12 @@
   {"Select_range_check",       (char*) offsetof(STATUS_VAR, select_range_check_count), SHOW_LONG_STATUS},
   {"Select_scan",	       (char*) offsetof(STATUS_VAR, select_scan_count), SHOW_LONG_STATUS},
   {"Slave_open_temp_tables",   (char*) &slave_open_temp_tables, SHOW_LONG},
+#ifdef HAVE_REPLICATION
   {"Slave_retried_transactions",(char*) &show_slave_retried_trans, SHOW_FUNC},
   {"Slave_heartbeat_period",   (char*) &show_heartbeat_period, SHOW_FUNC},
   {"Slave_received_heartbeats",(char*) &show_slave_received_heartbeats, SHOW_FUNC},
   {"Slave_running",            (char*) &show_slave_running,     SHOW_FUNC},
+#endif
   {"Slow_launch_threads",      (char*) &slow_launch_threads,    SHOW_LONG},
   {"Slow_queries",             (char*) offsetof(STATUS_VAR, long_query_count), SHOW_LONG_STATUS},
   {"Sort_merge_passes",	       (char*) offsetof(STATUS_VAR, filesort_merge_passes), SHOW_LONG_STATUS},
@@ -4704,6 +4760,7 @@
   binlog_cache_use=  binlog_cache_disk_use= 0;
   max_used_connections= slow_launch_threads = 0;
   mysqld_user= mysqld_chroot= opt_init_file= opt_bin_logname = 0;
+  prepared_stmt_count= 0;
   errmesg= 0;
   opt_mysql_tmpdir= my_bind_addr_str= NullS;
   bzero((uchar*) &mysql_tmpdir_list, sizeof(mysql_tmpdir_list));
@@ -4899,6 +4956,7 @@
   case (int) OPT_ERROR_LOG_FILE:
     opt_error_log= 1;
     break;
+#ifdef HAVE_REPLICATION
   case (int)OPT_REPLICATE_IGNORE_DB:
   {
     rpl_filter->add_ignore_db(argument);
@@ -4996,6 +5054,7 @@
     }
     break;
   }
+#endif /* HAVE_REPLICATION */
   case (int) OPT_SLOW_QUERY_LOG:
     opt_slow_log= 1;
     break;
@@ -5432,11 +5491,13 @@
 
   if (init_tmpdir(&mysql_tmpdir_list, opt_mysql_tmpdir))
     exit(1);
+#ifdef HAVE_REPLICATION
   if (!slave_load_tmpdir)
   {
     if (!(slave_load_tmpdir = (char*) my_strdup(mysql_tmpdir, MYF(MY_FAE))))
       exit(1);
   }
+#endif /* HAVE_REPLICATION */
   /*
     Convert the secure-file-priv option to system format, allowing
     a quick strcmp to check if read or write is in an allowed dir
@@ -5555,7 +5616,7 @@
   int result= 0;
   File file;
   char buff[FN_REFLEN], buff2[FN_REFLEN];
-  struct stat stat_info;
+  MY_STAT stat_info;
   DBUG_ENTER("test_if_case_insensitive");
 
   fn_format(buff, glob_hostname, dir_name, ".lower-test",
@@ -5569,7 +5630,7 @@
     DBUG_RETURN(-1);
   }
   my_close(file, MYF(0));
-  if (!stat(buff2, &stat_info))
+  if (my_stat(buff2, &stat_info, MYF(0)))
     result= 1;					// Can access file
   (void) my_delete(buff, MYF(MY_WME));
   DBUG_PRINT("exit", ("result: %d", result));

=== modified file 'sql/net_serv.cc'
--- sql/net_serv.cc	2008-06-29 19:19:20 +0000
+++ sql/net_serv.cc	2008-06-25 05:29:13 +0000
@@ -59,6 +59,7 @@
 */
 extern uint test_flags;
 extern ulong bytes_sent, bytes_received, net_big_packet_count;
+extern pthread_mutex_t LOCK_bytes_sent , LOCK_bytes_received;
 #ifndef MYSQL_INSTANCE_MANAGER
 #define update_statistics(A) A
 #endif /* MYSQL_INSTANCE_MANGER */

=== modified file 'sql/rpl_rli.cc'
--- sql/rpl_rli.cc	2008-06-30 00:30:38 +0000
+++ sql/rpl_rli.cc	2008-06-25 05:29:13 +0000
@@ -17,7 +17,7 @@
 
 #include "rpl_mi.h"
 #include "rpl_rli.h"
-#include <my_dir.h>
+#include <my_dir.h>    // For MY_STAT
 #include "sql_repl.h"  // For check_binlog_magic
 #include "rpl_utility.h"
 
@@ -300,9 +300,9 @@
 
 static inline int add_relay_log(Relay_log_info* rli,LOG_INFO* linfo)
 {
-  struct stat s;
+  MY_STAT s;
   DBUG_ENTER("add_relay_log");
-  if (stat(linfo->log_file_name,&s))
+  if (!my_stat(linfo->log_file_name,&s,MYF(0)))
   {
     sql_print_error("log %s listed in the index, but failed to stat",
                     linfo->log_file_name);

=== modified file 'sql/set_var.cc'
--- sql/set_var.cc	2008-06-30 00:30:38 +0000
+++ sql/set_var.cc	2008-06-25 05:29:13 +0000
@@ -2162,7 +2162,7 @@
 static int  sys_check_log_path(THD *thd,  set_var *var)
 {
   char path[FN_REFLEN], buff[FN_REFLEN];
-  struct stat f_stat;
+  MY_STAT f_stat;
   String str(buff, sizeof(buff), system_charset_info), *res;
   const char *log_file_str;
   size_t path_length;
@@ -2171,7 +2171,7 @@
     goto err;
 
   log_file_str= res->c_ptr();
-  bzero(&f_stat, sizeof(struct stat));
+  bzero(&f_stat, sizeof(MY_STAT));
 
   path_length= unpack_filename(path, log_file_str);
 
@@ -2182,7 +2182,7 @@
     goto err;
   }
 
-  if (!stat(path, &f_stat))
+  if (my_stat(path, &f_stat, MYF(0)))
   {
     /*
       A file system object exists. Check if argument is a file and we have

=== modified file 'sql/sql_bitmap.h'
--- sql/sql_bitmap.h	2008-06-30 01:17:15 +0000
+++ sql/sql_bitmap.h	2008-06-25 05:29:13 +0000
@@ -157,7 +157,16 @@
   ulonglong map;
 public:
   Bitmap<64>() { map= 0; }
+#if defined(__NETWARE__) || defined(__MWERKS__)
+  /*
+    Metwork compiler gives error on Bitmap<64>
+    Changed to Bitmap, since in this case also it will proper construct
+    this class
+  */
+  explicit Bitmap(uint prefix_to_set) { set_prefix(prefix_to_set); }
+#else
   explicit Bitmap<64>(uint prefix_to_set) { set_prefix(prefix_to_set); }
+#endif
   void init() { }
   void init(uint prefix_to_set) { set_prefix(prefix_to_set); }
   uint length() const { return 64; }

=== modified file 'sql/sql_db.cc'
--- sql/sql_db.cc	2008-06-30 04:12:46 +0000
+++ sql/sql_db.cc	2008-06-25 05:29:13 +0000
@@ -607,7 +607,7 @@
   char	 tmp_query[FN_REFLEN+16];
   long result= 1;
   int error= 0;
-  struct stat stat_info;
+  MY_STAT stat_info;
   uint create_options= create_info ? create_info->options : 0;
   uint path_len;
   DBUG_ENTER("mysql_create_db");
@@ -643,7 +643,7 @@
   path_len= build_table_filename(path, sizeof(path), db, "", "", 0);
   path[path_len-1]= 0;                    // Remove last '/' from path
 
-  if (!stat(path,&stat_info))
+  if (my_stat(path,&stat_info,MYF(0)))
   {
     if (!(create_options & HA_LEX_CREATE_IF_NOT_EXISTS))
     {
@@ -660,9 +660,9 @@
   }
   else
   {
-    if (errno != ENOENT)
+    if (my_errno != ENOENT)
     {
-      my_error(EE_STAT, MYF(0), path, errno);
+      my_error(EE_STAT, MYF(0), path, my_errno);
       goto exit;
     }
     if (my_mkdir(path,0777,MYF(0)) < 0)

=== modified file 'sql/sql_lex.h'
--- sql/sql_lex.h	2008-06-29 19:19:20 +0000
+++ sql/sql_lex.h	2008-06-25 05:29:13 +0000
@@ -81,8 +81,9 @@
   SQLCOM_RESET, SQLCOM_PURGE, SQLCOM_PURGE_BEFORE, SQLCOM_SHOW_BINLOGS,
   SQLCOM_SHOW_OPEN_TABLES,
   SQLCOM_SHOW_SLAVE_HOSTS, SQLCOM_DELETE_MULTI, SQLCOM_UPDATE_MULTI,
-  SQLCOM_SHOW_BINLOG_EVENTS,
+  SQLCOM_SHOW_BINLOG_EVENTS, SQLCOM_SHOW_NEW_MASTER,
   SQLCOM_SHOW_WARNS, SQLCOM_EMPTY_QUERY, SQLCOM_SHOW_ERRORS,
+  SQLCOM_SHOW_STORAGE_ENGINES,
   SQLCOM_CHECKSUM,
   SQLCOM_PREPARE, SQLCOM_EXECUTE, SQLCOM_DEALLOCATE_PREPARE,
   SQLCOM_XA_START, SQLCOM_XA_END, SQLCOM_XA_PREPARE,

=== modified file 'sql/sql_load.cc'
--- sql/sql_load.cc	2008-06-30 00:30:38 +0000
+++ sql/sql_load.cc	2008-06-25 05:29:13 +0000
@@ -307,8 +307,8 @@
         DBUG_RETURN(TRUE);
       }
 
-      struct stat stat_info;
-      if (stat(name,&stat_info))
+      MY_STAT stat_info;
+      if (!my_stat(name,&stat_info,MYF(MY_WME)))
 	DBUG_RETURN(TRUE);
 
       // if we are not in slave thread, the file must be:

=== modified file 'sql/sql_parse.cc'
--- sql/sql_parse.cc	2008-06-29 19:19:20 +0000
+++ sql/sql_parse.cc	2008-06-28 02:03:37 +0000
@@ -139,6 +139,7 @@
   return error;
 }
 
+#ifdef HAVE_REPLICATION
 /**
   Returns true if all tables should be ignored.
 */
@@ -147,6 +148,7 @@
   return rpl_filter->is_on() && tables &&
          !rpl_filter->tables_ok(thd->db, tables);
 }
+#endif
 
 
 static bool some_non_temp_table_to_be_updated(THD *thd, TABLE_LIST *tables)
@@ -209,6 +211,7 @@
   sql_command_flags[SQLCOM_SHOW_VARIABLES]=   CF_STATUS_COMMAND;
   sql_command_flags[SQLCOM_SHOW_CHARSETS]=    CF_STATUS_COMMAND;
   sql_command_flags[SQLCOM_SHOW_COLLATIONS]=  CF_STATUS_COMMAND;
+  sql_command_flags[SQLCOM_SHOW_NEW_MASTER]= CF_STATUS_COMMAND;
   sql_command_flags[SQLCOM_SHOW_BINLOGS]= CF_STATUS_COMMAND;
   sql_command_flags[SQLCOM_SHOW_SLAVE_HOSTS]= CF_STATUS_COMMAND;
   sql_command_flags[SQLCOM_SHOW_BINLOG_EVENTS]= CF_STATUS_COMMAND;
@@ -1452,6 +1455,7 @@
   if (all_tables || !lex->is_single_level_stmt())
     mysql_reset_errors(thd, 0);
 
+#ifdef HAVE_REPLICATION
   if (unlikely(thd->slave_thread))
   {
     /*
@@ -1497,6 +1501,7 @@
   }
   else
   {
+#endif /* HAVE_REPLICATION */
     /*
       When option readonly is set deny operations which change non-temporary
       tables. Except for the replication thread and the 'super' users.
@@ -1506,7 +1511,9 @@
       my_error(ER_OPTION_PREVENTS_STATEMENT, MYF(0), "--read-only");
       DBUG_RETURN(-1);
     }
+#ifdef HAVE_REPLICATION
   } /* endif unlikely slave */
+#endif
   status_var_increment(thd->status_var.com_stat[lex->sql_command]);
 
   DBUG_ASSERT(thd->transaction.stmt.modified_non_trans_table == FALSE);
@@ -1603,6 +1610,19 @@
 			      (1L << (uint) MYSQL_ERROR::WARN_LEVEL_ERROR));
     break;
   }
+  case SQLCOM_SHOW_NEW_MASTER:
+  {
+    /* This query don't work now. See comment in repl_failsafe.cc */
+#ifndef WORKING_NEW_MASTER
+    my_error(ER_NOT_SUPPORTED_YET, MYF(0), "SHOW NEW MASTER");
+    goto error;
+#else
+    res = show_new_master(thd);
+    break;
+#endif
+  }
+
+#ifdef HAVE_REPLICATION
   case SQLCOM_SHOW_SLAVE_HOSTS:
   {
     res = show_slave_hosts(thd);
@@ -1613,6 +1633,7 @@
     res = mysql_show_binlog_events(thd);
     break;
   }
+#endif
 
   case SQLCOM_ASSIGN_TO_KEYCACHE:
   {
@@ -1626,6 +1647,7 @@
     res = mysql_preload_keys(thd, first_table);
     break;
   }
+#ifdef HAVE_REPLICATION
   case SQLCOM_CHANGE_MASTER:
   {
     pthread_mutex_lock(&LOCK_active_mi);
@@ -1655,6 +1677,7 @@
     break;
   }
 
+#endif /* HAVE_REPLICATION */
   case SQLCOM_SHOW_ENGINE_STATUS:
     {
       res = ha_show_status(thd, lex->create_info.db_type, HA_ENGINE_STATUS);

=== modified file 'sql/sql_repl.cc'
--- sql/sql_repl.cc	2008-06-30 00:30:38 +0000
+++ sql/sql_repl.cc	2008-06-25 05:29:13 +0000
@@ -1080,7 +1080,7 @@
 
 int reset_slave(THD *thd, Master_info* mi)
 {
-  struct stat stat_area;
+  MY_STAT stat_area;
   char fname[FN_REFLEN];
   int thread_mask= 0, error= 0;
   uint sql_errno=0;
@@ -1117,14 +1117,14 @@
   end_master_info(mi);
   // and delete these two files
   fn_format(fname, master_info_file, mysql_data_home, "", 4+32);
-  if (!stat(fname, &stat_area) && my_delete(fname, MYF(MY_WME)))
+  if (my_stat(fname, &stat_area, MYF(0)) && my_delete(fname, MYF(MY_WME)))
   {
     error=1;
     goto err;
   }
   // delete relay_log_info_file
   fn_format(fname, relay_log_info_file, mysql_data_home, "", 4+32);
-  if (!stat(fname, &stat_area) && my_delete(fname, MYF(MY_WME)))
+  if (my_stat(fname, &stat_area, MYF(0)) && my_delete(fname, MYF(MY_WME)))
   {
     error=1;
     goto err;

=== modified file 'sql/sql_show.cc'
--- sql/sql_show.cc	2008-06-30 00:30:38 +0000
+++ sql/sql_show.cc	2008-06-25 05:29:13 +0000
@@ -260,7 +260,7 @@
 	end= strend(buff);
 	if (end != buff && end[-1] == FN_LIBCHAR)
 	  end[-1]= 0;				// Remove end FN_LIBCHAR
-        if (stat(buff, file->mystat))
+        if (!my_stat(buff, file->mystat, MYF(0)))
                continue;
        }
 #endif
@@ -2832,13 +2832,13 @@
   {
     char path[FN_REFLEN+16];
     uint path_len;
-    struct stat stat_info;
+    MY_STAT stat_info;
     if (!lookup_field_vals.db_value.str[0])
       DBUG_RETURN(0);
     path_len= build_table_filename(path, sizeof(path),
                                    lookup_field_vals.db_value.str, "", "", 0);
     path[path_len-1]= 0;
-    if (stat(path,&stat_info))
+    if (!my_stat(path,&stat_info,MYF(0)))
       DBUG_RETURN(0);
   }
 

=== modified file 'sql/sql_table.cc'
--- sql/sql_table.cc	2008-06-30 00:30:38 +0000
+++ sql/sql_table.cc	2008-06-25 05:29:13 +0000
@@ -3322,7 +3322,7 @@
   TABLE_SHARE *share;
   char from[FN_REFLEN],tmp[FN_REFLEN+32];
   const char **ext;
-  struct stat stat_info;
+  MY_STAT stat_info;
   DBUG_ENTER("prepare_for_repair");
 
   if (!(check_opt->sql_flags & TT_USEFRM))
@@ -3384,7 +3384,7 @@
 
   // Name of data file
   strxmov(from, table->s->normalized_path.str, ext[1], NullS);
-  if (stat(from, &stat_info))
+  if (!my_stat(from, &stat_info, MYF(0)))
     goto end;				// Can't use USE_FRM flag
 
   my_snprintf(tmp, sizeof(tmp), "%s-%lx_%lx",

=== modified file 'sql/sql_yacc.yy'
--- sql/sql_yacc.yy	2008-06-29 19:19:20 +0000
+++ sql/sql_yacc.yy	2008-06-25 05:29:13 +0000
@@ -5650,6 +5650,19 @@
             if (prepare_schema_table(YYTHD, lex, $4, SCH_COLUMNS))
               MYSQL_YYABORT;
           }
+        | NEW_SYM MASTER_SYM FOR_SYM SLAVE
+          WITH MASTER_LOG_FILE_SYM EQ
+          TEXT_STRING_sys /* $8 */
+          AND_SYM MASTER_LOG_POS_SYM EQ
+          ulonglong_num /* $12 */
+          AND_SYM MASTER_SERVER_ID_SYM EQ
+          ulong_num /* $16 */
+          {
+            Lex->sql_command = SQLCOM_SHOW_NEW_MASTER;
+            Lex->mi.log_file_name = $8.str;
+            Lex->mi.pos = $12;
+            Lex->mi.server_id = $16;
+          }
         | master_or_binary LOGS_SYM
           {
             Lex->sql_command = SQLCOM_SHOW_BINLOGS;

=== modified file 'sql/stacktrace.h'
--- sql/stacktrace.h	2008-06-30 01:17:15 +0000
+++ sql/stacktrace.h	2008-06-25 05:29:13 +0000
@@ -55,7 +55,14 @@
 #endif /* HAVE_STACKTRACE */
 
 
+#if !defined(__NETWARE__)
+#define HAVE_WRITE_CORE
+#endif
+
+#ifdef HAVE_WRITE_CORE
 void write_core(int sig);
+#endif
+
 
 #ifdef	__cplusplus
 }

=== modified file 'sql/tztime.cc'
--- sql/tztime.cc	2008-06-30 01:17:15 +0000
+++ sql/tztime.cc	2008-06-28 01:01:34 +0000
@@ -2446,6 +2446,7 @@
 int
 main(int argc, char **argv)
 {
+#ifndef __NETWARE__
   MY_INIT(argv[0]);
 
   if (argc != 2 && argc != 3)
@@ -2504,6 +2505,10 @@
     free_root(&tz_storage, MYF(0));
   }
 
+#else
+  fprintf(stderr, "This tool has not been ported to NetWare\n");
+#endif /* __NETWARE__ */
+
   return 0;
 }
 

=== modified file 'storage/archive/ha_archive.cc'
--- storage/archive/ha_archive.cc	2008-06-30 00:30:38 +0000
+++ storage/archive/ha_archive.cc	2008-06-25 05:29:13 +0000
@@ -231,11 +231,11 @@
   azio_stream frm_stream;
   char az_file[FN_REFLEN];
   char *frm_ptr;
-  struct stat file_stat; 
+  MY_STAT file_stat; 
 
   fn_format(az_file, name, db, ARZ, MY_REPLACE_EXT | MY_UNPACK_FILENAME);
 
-  if (stat(az_file, &file_stat))
+  if (!(my_stat(az_file, &file_stat, MYF(0))))
     goto err;
 
   if (!(azopen(&frm_stream, az_file, O_RDONLY|O_BINARY, AZ_METHOD_BLOCK)))
@@ -583,7 +583,7 @@
   int error;
   azio_stream create_stream;            /* Archive file we are working with */
   File frm_file;                   /* File handler for readers */
-  struct stat file_stat;
+  MY_STAT file_stat;  // Stat information for the data file
   uchar *frm_ptr;
 
   DBUG_ENTER("ha_archive::create");
@@ -633,7 +633,7 @@
     There is a chance that the file was "discovered". In this case
     just use whatever file is there.
   */
-  if (!stat(name_buff, &file_stat))
+  if (!(my_stat(name_buff, &file_stat, MYF(0))))
   {
     my_errno= 0;
     if (!(azopen(&create_stream, name_buff, O_CREAT|O_RDWR|O_BINARY,
@@ -653,7 +653,7 @@
     */
     if ((frm_file= my_open(name_buff, O_RDONLY, MYF(0))) > 0)
     {
-      if (fstat(frm_file, &file_stat))
+      if (!my_fstat(frm_file, &file_stat, MYF(MY_WME)))
       {
         frm_ptr= (uchar *)my_malloc(sizeof(uchar) * file_stat.st_size, MYF(0));
         if (frm_ptr)
@@ -1383,9 +1383,9 @@
   /* Costs quite a bit more to get all information */
   if (flag & HA_STATUS_TIME)
   {
-    struct stat file_stat;  // Stat information for the data file
+    MY_STAT file_stat;  // Stat information for the data file
 
-    VOID(stat(share->data_file_name, &file_stat));
+    VOID(my_stat(share->data_file_name, &file_stat, MYF(MY_WME)));
 
     stats.mean_rec_length= table->s->reclength + buffer.alloced_length();
     stats.data_file_length= file_stat.st_size;

=== modified file 'storage/csv/ha_tina.cc'
--- storage/csv/ha_tina.cc	2008-06-30 00:30:38 +0000
+++ storage/csv/ha_tina.cc	2008-06-25 05:29:13 +0000
@@ -136,7 +136,7 @@
 {
   TINA_SHARE *share;
   char meta_file_name[FN_REFLEN];
-  struct stat file_stat;
+  MY_STAT file_stat;                /* Stat information for the data file */
   char *tmp_name;
   uint length;
 
@@ -175,7 +175,7 @@
     fn_format(meta_file_name, table_name, "", CSM_EXT,
               MY_REPLACE_EXT|MY_UNPACK_FILENAME);
 
-    if (stat(share->data_file_name, &file_stat))
+    if (my_stat(share->data_file_name, &file_stat, MYF(MY_WME)) == NULL)
       goto error;
     share->saved_data_file_length= file_stat.st_size;
 

=== modified file 'storage/myisam/mi_info.c'
--- storage/myisam/mi_info.c	2008-06-30 00:30:38 +0000
+++ storage/myisam/mi_info.c	2008-06-25 05:29:13 +0000
@@ -33,7 +33,7 @@
 
 int mi_status(MI_INFO *info, register MI_ISAMINFO *x, uint flag)
 {
-  struct stat state;
+  MY_STAT state;
   MYISAM_SHARE *share=info->s;
   DBUG_ENTER("mi_status");
 
@@ -85,7 +85,7 @@
     x->data_file_name   = share->data_file_name;
     x->index_file_name  = share->index_file_name;
   }
-  if ((flag & HA_STATUS_TIME) && !fstat(info->dfile,&state))
+  if ((flag & HA_STATUS_TIME) && !my_fstat(info->dfile,&state,MYF(0)))
     x->update_time=state.st_mtime;
   else
     x->update_time=0;

